/* A Bison parser, made by GNU Bison 2.5.  */

/* Bison implementation for Yacc-like parsers in C
   
      Copyright (C) 1984, 1989-1990, 2000-2011 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.5"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Copy the first part of user declarations.  */

/* Line 268 of yacc.c  */
#line 1 "gram.y"

/* $Header$ */

/*
 * Copyright © 1988-2004 Keith Packard and Bart Massey.
 * All Rights Reserved.  See the file COPYING in this directory
 * for licensing information.
 */

#include	"nickle.h"
#include	<stdio.h>

/*
 * This grammar generates 1 shift/reduce conflict and 4 reduce/reduce:
 * 
 * 2 reduce/reduce conflicts on:
 *
 *	    *int . func 
 *	    **int . func
 *
 *	Is the '*' a dereference operator or a pointer type modifier?
 *	The grammar is ordered to make this a type modifier since
 *	the other way is less common.  Use parens when you want this.
 *
 * 2 reduce/reduce conflicts on:
 *
 *	   &int . func
 *	   &&int . func
 *
 *	Is the '&' a reference operator or a reference type modifier?
 *	The grammar is ordered to make this a type modifier since
 *	the other way is less common.  Use parens when you want this.
 *
 *  shift/reduce conflict in ASSIGN in initializers
 *
 *	That's because struct initializers look like assignment
 *	expressions while array initializers permit any expression.
 *	Shift yields struct initialization, so the effect is
 *	to make assignment expressions invalid in array initializers.
 *	(Of course, you can always enclose an assignment in parens.)
 *      (I can't see any obvious way to use operator precedence to
 *      get rid of this: seems like you'd need to duplicate simpleexpr
 *      with different precedence. --BCM)
 *
 */
int ignorenl;
int notCommand;
int seeComment;
NamespacePtr	LexNamespace;
int funcDepth;

void ParseError (char *fmt, ...);
void yyerror (char *msg);

typedef enum _CanonTypeResult {
    CanonTypeUndefined,
    CanonTypeForward,
    CanonTypeDefined,
} CanonTypeResult;
    
static Expr *
ParseCanonFor (Expr *expr);

static CanonTypeResult
ParseCanonType (TypePtr type, Bool forwardAllowed);

static SymbolPtr
ParseNewSymbol (Publish publish, Class class, Type *type, Atom name);



/* Line 268 of yacc.c  */
#line 143 "gram.c"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     VAR = 258,
     EXPR = 259,
     ARRAY = 260,
     STRUCT = 261,
     UNION = 262,
     ENUM = 263,
     COMP = 264,
     HASH = 265,
     SEMI = 266,
     MOD = 267,
     OC = 268,
     CC = 269,
     DOLLAR = 270,
     DOTDOTDOT = 271,
     ENDFILE = 272,
     GLOBAL = 273,
     AUTO = 274,
     STATIC = 275,
     CONST = 276,
     POLY = 277,
     INTEGER = 278,
     NATURAL = 279,
     RATIONAL = 280,
     REAL = 281,
     STRING = 282,
     FOREIGN = 283,
     FILET = 284,
     MUTEX = 285,
     SEMAPHORE = 286,
     CONTINUATION = 287,
     THREAD = 288,
     VOID = 289,
     BOOL = 290,
     FUNCTION = 291,
     FUNC = 292,
     EXCEPTION = 293,
     RAISE = 294,
     TYPEDEF = 295,
     IMPORT = 296,
     NEW = 297,
     ANONINIT = 298,
     NAMESPACE = 299,
     PUBLIC = 300,
     PROTECTED = 301,
     EXTEND = 302,
     WHILE = 303,
     DO = 304,
     FOR = 305,
     SWITCH = 306,
     BREAK = 307,
     CONTINUE = 308,
     RETURNTOK = 309,
     FORK = 310,
     CASE = 311,
     DEFAULT = 312,
     TWIXT = 313,
     NAME = 314,
     TYPENAME = 315,
     NAMESPACENAME = 316,
     COMMAND = 317,
     NAMECOMMAND = 318,
     TEN_NUM = 319,
     OCTAL0_NUM = 320,
     OCTAL_NUM = 321,
     BINARY_NUM = 322,
     HEX_NUM = 323,
     TEN_FLOAT = 324,
     OCTAL0_FLOAT = 325,
     OCTAL_FLOAT = 326,
     BINARY_FLOAT = 327,
     HEX_FLOAT = 328,
     CHAR_CONST = 329,
     STRING_CONST = 330,
     POLY_CONST = 331,
     THREAD_CONST = 332,
     COMMENT_CONST = 333,
     VOIDVAL = 334,
     BOOLVAL = 335,
     DARROW = 336,
     ISTYPE = 337,
     HASMEMBER = 338,
     POUND = 339,
     COMMA = 340,
     ASSIGNAND = 341,
     ASSIGNOR = 342,
     ASSIGNLOR = 343,
     ASSIGNLAND = 344,
     ASSIGNLXOR = 345,
     ASSIGNSHIFTR = 346,
     ASSIGNSHIFTL = 347,
     ASSIGNPOW = 348,
     ASSIGNMOD = 349,
     ASSIGNDIV = 350,
     ASSIGNDIVIDE = 351,
     ASSIGNTIMES = 352,
     ASSIGNMINUS = 353,
     ASSIGNPLUS = 354,
     ASSIGN = 355,
     COLON = 356,
     QUEST = 357,
     OR = 358,
     AND = 359,
     LOR = 360,
     LXOR = 361,
     LAND = 362,
     NE = 363,
     EQ = 364,
     GE = 365,
     LE = 366,
     GT = 367,
     LT = 368,
     SHIFTR = 369,
     SHIFTL = 370,
     MINUS = 371,
     PLUS = 372,
     DIV = 373,
     DIVIDE = 374,
     TIMES = 375,
     POW3 = 376,
     POW2 = 377,
     STARSTAR = 378,
     POW = 379,
     UNIONCAST = 380,
     THREADID = 381,
     AMPER = 382,
     STAR = 383,
     DEC = 384,
     INC = 385,
     LNOT = 386,
     FACT = 387,
     BANG = 388,
     UMINUS = 389,
     CP = 390,
     OP = 391,
     CALL = 392,
     STAROS = 393,
     ARROW = 394,
     DOT = 395,
     CS = 396,
     OS = 397,
     POINTER = 398,
     COLONCOLON = 399,
     NONL = 400,
     TRY = 401,
     IF = 402,
     NL = 403,
     CATCH = 404,
     ELSE = 405
   };
#endif
/* Tokens.  */
#define VAR 258
#define EXPR 259
#define ARRAY 260
#define STRUCT 261
#define UNION 262
#define ENUM 263
#define COMP 264
#define HASH 265
#define SEMI 266
#define MOD 267
#define OC 268
#define CC 269
#define DOLLAR 270
#define DOTDOTDOT 271
#define ENDFILE 272
#define GLOBAL 273
#define AUTO 274
#define STATIC 275
#define CONST 276
#define POLY 277
#define INTEGER 278
#define NATURAL 279
#define RATIONAL 280
#define REAL 281
#define STRING 282
#define FOREIGN 283
#define FILET 284
#define MUTEX 285
#define SEMAPHORE 286
#define CONTINUATION 287
#define THREAD 288
#define VOID 289
#define BOOL 290
#define FUNCTION 291
#define FUNC 292
#define EXCEPTION 293
#define RAISE 294
#define TYPEDEF 295
#define IMPORT 296
#define NEW 297
#define ANONINIT 298
#define NAMESPACE 299
#define PUBLIC 300
#define PROTECTED 301
#define EXTEND 302
#define WHILE 303
#define DO 304
#define FOR 305
#define SWITCH 306
#define BREAK 307
#define CONTINUE 308
#define RETURNTOK 309
#define FORK 310
#define CASE 311
#define DEFAULT 312
#define TWIXT 313
#define NAME 314
#define TYPENAME 315
#define NAMESPACENAME 316
#define COMMAND 317
#define NAMECOMMAND 318
#define TEN_NUM 319
#define OCTAL0_NUM 320
#define OCTAL_NUM 321
#define BINARY_NUM 322
#define HEX_NUM 323
#define TEN_FLOAT 324
#define OCTAL0_FLOAT 325
#define OCTAL_FLOAT 326
#define BINARY_FLOAT 327
#define HEX_FLOAT 328
#define CHAR_CONST 329
#define STRING_CONST 330
#define POLY_CONST 331
#define THREAD_CONST 332
#define COMMENT_CONST 333
#define VOIDVAL 334
#define BOOLVAL 335
#define DARROW 336
#define ISTYPE 337
#define HASMEMBER 338
#define POUND 339
#define COMMA 340
#define ASSIGNAND 341
#define ASSIGNOR 342
#define ASSIGNLOR 343
#define ASSIGNLAND 344
#define ASSIGNLXOR 345
#define ASSIGNSHIFTR 346
#define ASSIGNSHIFTL 347
#define ASSIGNPOW 348
#define ASSIGNMOD 349
#define ASSIGNDIV 350
#define ASSIGNDIVIDE 351
#define ASSIGNTIMES 352
#define ASSIGNMINUS 353
#define ASSIGNPLUS 354
#define ASSIGN 355
#define COLON 356
#define QUEST 357
#define OR 358
#define AND 359
#define LOR 360
#define LXOR 361
#define LAND 362
#define NE 363
#define EQ 364
#define GE 365
#define LE 366
#define GT 367
#define LT 368
#define SHIFTR 369
#define SHIFTL 370
#define MINUS 371
#define PLUS 372
#define DIV 373
#define DIVIDE 374
#define TIMES 375
#define POW3 376
#define POW2 377
#define STARSTAR 378
#define POW 379
#define UNIONCAST 380
#define THREADID 381
#define AMPER 382
#define STAR 383
#define DEC 384
#define INC 385
#define LNOT 386
#define FACT 387
#define BANG 388
#define UMINUS 389
#define CP 390
#define OP 391
#define CALL 392
#define STAROS 393
#define ARROW 394
#define DOT 395
#define CS 396
#define OS 397
#define POINTER 398
#define COLONCOLON 399
#define NONL 400
#define TRY 401
#define IF 402
#define NL 403
#define CATCH 404
#define ELSE 405




#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 293 of yacc.c  */
#line 72 "gram.y"

    int		    ints;
    Value	    value;
    Class	    class;
    ArgType	    *argType;
    Type	    *type;
    Publish	    publish;
    ExprPtr	    expr;
    Atom	    atom;
    DeclListPtr	    declList;
    MemListPtr	    memList;
    Fulltype	    fulltype;
    ArgDecl	    argDecl;
    SymbolPtr	    symbol;
    NamespacePtr    namespace;
    CodePtr	    code;
    Bool	    bool;
    AtomListPtr	    atomList;
    FuncDecl	    funcDecl;



/* Line 293 of yacc.c  */
#line 502 "gram.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif


/* Copy the second part of user declarations.  */


/* Line 343 of yacc.c  */
#line 514 "gram.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  2
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   4996

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  151
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  116
/* YYNRULES -- Number of rules.  */
#define YYNRULES  348
/* YYNRULES -- Number of states.  */
#define YYNSTATES  684

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   405

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     6,     7,     9,    13,    15,    17,    19,
      20,    21,    22,    23,    25,    26,    28,    29,    31,    32,
      37,    44,    49,    56,    63,    65,    67,    69,    70,    74,
      76,    79,    81,    83,    85,    89,    90,    93,    95,    98,
     100,   102,   106,   110,   113,   115,   117,   118,   119,   123,
     126,   129,   132,   133,   141,   151,   153,   155,   159,   169,
     180,   190,   200,   211,   214,   217,   221,   224,   226,   231,
     242,   249,   256,   264,   265,   275,   282,   285,   297,   301,
     303,   305,   309,   314,   317,   318,   326,   328,   330,   331,
     334,   336,   341,   343,   345,   346,   349,   351,   352,   356,
     359,   360,   365,   369,   373,   376,   377,   385,   389,   391,
     392,   396,   398,   402,   404,   406,   408,   413,   416,   418,
     420,   425,   429,   434,   439,   442,   445,   446,   451,   455,
     458,   461,   466,   471,   476,   481,   482,   485,   488,   491,
     494,   497,   501,   503,   508,   513,   518,   522,   524,   526,
     527,   529,   531,   533,   535,   537,   539,   541,   543,   545,
     547,   549,   551,   553,   555,   556,   560,   562,   566,   568,
     572,   574,   579,   580,   585,   586,   588,   589,   591,   593,
     595,   597,   599,   600,   602,   604,   606,   608,   612,   615,
     619,   622,   625,   627,   631,   634,   636,   640,   643,   646,
     648,   650,   651,   653,   654,   656,   659,   661,   665,   667,
     668,   672,   674,   676,   677,   681,   684,   688,   689,   692,
     696,   704,   707,   710,   713,   716,   719,   722,   725,   728,
     731,   734,   737,   740,   743,   746,   750,   754,   758,   762,
     766,   770,   774,   777,   780,   784,   788,   794,   798,   802,
     806,   810,   814,   818,   822,   826,   830,   834,   838,   840,
     842,   844,   846,   848,   850,   852,   854,   856,   858,   860,
     862,   864,   866,   868,   871,   878,   887,   896,   905,   909,
     916,   919,   921,   925,   929,   934,   939,   944,   951,   958,
     962,   966,   968,   969,   971,   973,   975,   977,   979,   981,
     983,   985,   987,   989,   991,   993,   995,   997,   999,  1001,
    1003,  1005,  1007,  1009,  1011,  1014,  1015,  1021,  1031,  1034,
    1036,  1040,  1042,  1044,  1045,  1049,  1051,  1053,  1055,  1057,
    1060,  1061,  1066,  1070,  1072,  1076,  1079,  1081,  1083,  1088,
    1092,  1094,  1098,  1102,  1107,  1112,  1114,  1116,  1118
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     152,     0,    -1,   152,   153,    -1,    -1,   162,    -1,     1,
     157,   154,    -1,   148,    -1,    11,    -1,    17,    -1,    -1,
      -1,    -1,    -1,   148,    -1,    -1,    11,    -1,    -1,    85,
      -1,    -1,   158,   238,   157,   148,    -1,   158,   238,    84,
     238,   157,   148,    -1,   158,   180,   157,   159,    -1,   158,
      62,   240,   157,   160,   148,    -1,   158,    63,   163,   157,
     160,   148,    -1,   148,    -1,    17,    -1,   164,    -1,    -1,
     165,    85,   164,    -1,   165,    -1,   167,   166,    -1,    59,
      -1,    61,    -1,    60,    -1,   167,   166,   144,    -1,    -1,
     171,    60,    -1,    60,    -1,   171,   172,    -1,   172,    -1,
     169,    -1,   169,    85,   170,    -1,   171,    61,   144,    -1,
      61,   144,    -1,    59,    -1,    61,    -1,    -1,    -1,   176,
     178,   177,    -1,    13,   173,    -1,   174,    14,    -1,   180,
     178,    -1,    -1,   147,   155,   173,   136,   238,   135,   180,
      -1,   147,   155,   173,   136,   238,   135,   180,   150,   180,
      -1,   181,    -1,   175,    -1,   179,   174,   156,    -1,    48,
     155,   173,   136,   238,   135,   180,   174,   156,    -1,    49,
     155,   173,   180,    48,   136,   238,   135,   174,   156,    -1,
      50,   155,   173,   136,   183,   135,   180,   174,   156,    -1,
      51,   155,   173,   136,   238,   135,   196,   174,   156,    -1,
     192,    51,   155,   173,   136,   238,   135,   199,   174,   156,
      -1,    52,    11,    -1,    53,    11,    -1,    54,   237,    11,
      -1,   238,    11,    -1,    11,    -1,   209,   194,   188,   174,
      -1,   226,    38,   155,    59,   173,   229,   174,   194,    11,
     156,    -1,    39,   169,   136,   240,   135,    11,    -1,   226,
      40,   155,   204,    11,   156,    -1,   226,    40,   155,   214,
     204,    11,   156,    -1,    -1,   228,    44,   155,   172,   182,
      13,   178,    14,   156,    -1,   226,    41,   155,   170,    11,
     156,    -1,   185,   156,    -1,    58,   155,   173,   136,   237,
      11,   237,   135,   180,   174,   156,    -1,   237,    11,   183,
      -1,   237,    -1,   181,    -1,    13,   178,    14,    -1,   146,
     155,   184,   186,    -1,   186,   187,    -1,    -1,   149,   169,
     173,   232,   194,   175,   174,    -1,   189,    -1,    11,    -1,
      -1,   190,   191,    -1,   175,    -1,   156,   100,   246,    11,
      -1,     7,    -1,     8,    -1,    -1,   193,   195,    -1,    78,
      -1,    -1,   176,   197,   177,    -1,   198,   197,    -1,    -1,
      56,   238,   101,   178,    -1,    57,   101,   178,    -1,   176,
     200,   177,    -1,   201,   200,    -1,    -1,    56,   173,    59,
     202,   101,   178,   174,    -1,    57,   101,   178,    -1,    59,
      -1,    -1,    59,    85,   203,    -1,    59,    -1,   205,    85,
     204,    -1,   205,    -1,    60,    -1,    59,    -1,   207,   211,
     208,   206,    -1,   207,   211,    -1,    59,    -1,    85,    -1,
     210,   173,   233,   135,    -1,   212,    59,   136,    -1,   212,
      36,    59,   136,    -1,    36,   155,    59,   136,    -1,   100,
     246,    -1,   100,   266,    -1,    -1,   227,   224,   216,   159,
      -1,   225,   216,   159,    -1,   214,   159,    -1,   229,   213,
      -1,   142,   218,   141,   213,    -1,   142,   220,   141,   213,
      -1,   142,   221,   141,   213,    -1,   142,   214,   141,   213,
      -1,    -1,   215,   213,    -1,   120,   214,    -1,   123,   214,
      -1,   104,   214,    -1,   107,   214,    -1,   214,   117,   214,
      -1,   217,    -1,     6,    13,   222,    14,    -1,     7,    13,
     223,    14,    -1,     8,    13,   203,    14,    -1,   136,   214,
     135,    -1,   168,    -1,   214,    -1,    -1,    22,    -1,    23,
      -1,    25,    -1,    26,    -1,    27,    -1,    29,    -1,    30,
      -1,    31,    -1,    32,    -1,    33,    -1,    34,    -1,    35,
      -1,    28,    -1,   219,    -1,    -1,   219,    85,   120,    -1,
     120,    -1,   220,    85,    16,    -1,    16,    -1,   246,    85,
     221,    -1,   246,    -1,   216,   203,    11,   222,    -1,    -1,
     216,   203,    11,   223,    -1,    -1,   225,    -1,    -1,    18,
      -1,    19,    -1,    20,    -1,    21,    -1,   227,    -1,    -1,
      45,    -1,    46,    -1,   226,    -1,    47,    -1,   136,   230,
     135,    -1,   136,   135,    -1,   231,    85,   230,    -1,   231,
     236,    -1,   214,    59,    -1,   214,    -1,   136,   233,   135,
      -1,   155,   234,    -1,   155,    -1,   235,    85,   234,    -1,
     235,   236,    -1,   216,    59,    -1,   214,    -1,    16,    -1,
      -1,   238,    -1,    -1,   239,    -1,   212,   206,    -1,   246,
      -1,   239,    85,   246,    -1,   241,    -1,    -1,   246,    85,
     241,    -1,   246,    -1,   243,    -1,    -1,   246,    85,   243,
      -1,   246,   236,    -1,   156,   100,   246,    -1,    -1,   245,
     175,    -1,   246,   248,   246,    -1,   216,    37,   173,   232,
     194,   244,   174,    -1,    12,   249,    -1,   120,   246,    -1,
     123,   246,    -1,   107,   246,    -1,   104,   246,    -1,   116,
     246,    -1,   131,   246,    -1,   133,   246,    -1,   246,   133,
      -1,   130,   246,    -1,   246,   130,    -1,   129,   246,    -1,
     246,   129,    -1,    55,   246,    -1,   246,   117,   246,    -1,
     246,   116,   246,    -1,   246,   120,   246,    -1,   246,   119,
     246,    -1,   246,   118,   246,    -1,   246,    12,   246,    -1,
     246,   123,   246,    -1,   246,   122,    -1,   246,   121,    -1,
     246,   115,   246,    -1,   246,   114,   246,    -1,   246,   102,
     246,   101,   246,    -1,   246,   106,   246,    -1,   246,   107,
     246,    -1,   246,   105,   246,    -1,   246,   104,   246,    -1,
     246,   103,   246,    -1,   246,   109,   246,    -1,   246,   108,
     246,    -1,   246,   113,   246,    -1,   246,   112,   246,    -1,
     246,   111,   246,    -1,   246,   110,   246,    -1,   169,    -1,
      64,    -1,    66,    -1,    65,    -1,    67,    -1,    68,    -1,
      69,    -1,    71,    -1,    70,    -1,    72,    -1,    73,    -1,
      74,    -1,    75,    -1,    79,    -1,    80,    -1,   142,   141,
      -1,   136,   214,   135,   173,   266,   174,    -1,   136,   142,
     219,   141,   135,   173,   251,   174,    -1,   136,   142,   221,
     141,   135,   173,   250,   174,    -1,   136,   142,   214,   141,
     135,   173,   258,   174,    -1,   214,   140,    59,    -1,   136,
     214,   140,    59,   135,   246,    -1,    15,   247,    -1,   140,
      -1,   136,   238,   135,    -1,   136,   175,   135,    -1,   246,
     138,   221,   141,    -1,   246,   142,   221,   141,    -1,   246,
     136,   242,   135,    -1,    82,   136,   246,    85,   214,   135,
      -1,    83,   136,   246,    85,    59,   135,    -1,   246,   140,
      59,    -1,   246,   139,    59,    -1,   249,    -1,    -1,    99,
      -1,    98,    -1,    97,    -1,    96,    -1,    95,    -1,    94,
      -1,    93,    -1,    92,    -1,    91,    -1,    90,    -1,    89,
      -1,    88,    -1,    87,    -1,    86,    -1,   100,    -1,    64,
      -1,    66,    -1,    65,    -1,    67,    -1,    68,    -1,   251,
      -1,    13,    14,    -1,    -1,    13,   256,   161,   236,    14,
      -1,    13,   142,   173,   253,   255,   141,   252,   174,    14,
      -1,   100,   257,    -1,   175,    -1,   254,    85,   253,    -1,
     254,    -1,    59,    -1,    -1,   256,    85,   257,    -1,   257,
      -1,   246,    -1,   266,    -1,   259,    -1,    13,    14,    -1,
      -1,    13,   260,   161,    14,    -1,   260,    85,   261,    -1,
     261,    -1,   246,    81,   262,    -1,    81,   262,    -1,   246,
      -1,   266,    -1,    13,   264,   161,    14,    -1,   264,    85,
     265,    -1,   265,    -1,    59,   100,   246,    -1,    59,   100,
     266,    -1,   140,    59,   100,   246,    -1,   140,    59,   100,
     266,    -1,   251,    -1,   263,    -1,   259,    -1,    13,    14,
      -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   191,   191,   192,   194,   195,   197,   199,   201,   210,
     213,   216,   234,   236,   237,   239,   240,   242,   243,   248,
     264,   280,   293,   317,   342,   343,   345,   347,   349,   351,
     354,   357,   358,   359,   361,   364,   366,   371,   377,   382,
     388,   392,   397,   420,   444,   445,   451,   454,   456,   459,
     461,   463,   466,   468,   470,   473,   474,   477,   479,   481,
     483,   488,   490,   492,   494,   496,   498,   500,   502,   529,
     544,   546,   555,   565,   564,   619,   659,   661,   667,   669,
     673,   674,   677,   681,   684,   686,   692,   693,   696,   696,
     698,   700,   707,   708,   711,   713,   716,   718,   720,   723,
     726,   728,   730,   733,   736,   739,   741,   756,   759,   767,
     772,   774,   777,   779,   782,   783,   793,   803,   814,   826,
     832,   865,   867,   869,   877,   879,   882,   887,   889,   891,
     897,   899,   901,   903,   905,   908,   910,   938,   940,   942,
     944,   946,   957,   958,   984,  1010,  1031,  1033,  1036,  1038,
    1040,  1041,  1042,  1043,  1044,  1045,  1046,  1047,  1048,  1049,
    1050,  1051,  1052,  1054,  1056,  1058,  1060,  1063,  1065,  1068,
    1070,  1076,  1079,  1081,  1084,  1089,  1091,  1093,  1094,  1095,
    1096,  1098,  1100,  1103,  1104,  1106,  1107,  1113,  1115,  1118,
    1120,  1123,  1129,  1140,  1143,  1168,  1171,  1173,  1176,  1178,
    1181,  1184,  1190,  1192,  1194,  1195,  1211,  1212,  1218,  1220,
    1222,  1224,  1227,  1229,  1231,  1233,  1239,  1245,  1245,  1250,
    1276,  1281,  1292,  1294,  1296,  1298,  1302,  1304,  1306,  1308,
    1314,  1316,  1318,  1320,  1322,  1324,  1326,  1328,  1330,  1332,
    1334,  1336,  1342,  1350,  1358,  1360,  1362,  1364,  1366,  1368,
    1370,  1372,  1374,  1376,  1378,  1380,  1382,  1384,  1386,  1387,
    1389,  1391,  1393,  1395,  1397,  1399,  1401,  1403,  1405,  1407,
    1409,  1411,  1413,  1415,  1419,  1427,  1434,  1443,  1452,  1458,
    1464,  1466,  1468,  1470,  1472,  1474,  1476,  1478,  1484,  1486,
    1488,  1491,  1493,  1494,  1495,  1496,  1497,  1498,  1499,  1500,
    1501,  1502,  1503,  1504,  1505,  1506,  1507,  1508,  1510,  1511,
    1512,  1513,  1514,  1519,  1520,  1523,  1525,  1539,  1544,  1546,
    1548,  1550,  1552,  1561,  1569,  1571,  1574,  1575,  1581,  1582,
    1585,  1587,  1593,  1595,  1598,  1600,  1603,  1604,  1609,  1612,
    1614,  1617,  1619,  1621,  1623,  1626,  1627,  1628,  1629
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "VAR", "EXPR", "ARRAY", "STRUCT",
  "UNION", "ENUM", "COMP", "HASH", "SEMI", "MOD", "OC", "CC", "DOLLAR",
  "DOTDOTDOT", "ENDFILE", "GLOBAL", "AUTO", "STATIC", "CONST", "POLY",
  "INTEGER", "NATURAL", "RATIONAL", "REAL", "STRING", "FOREIGN", "FILET",
  "MUTEX", "SEMAPHORE", "CONTINUATION", "THREAD", "VOID", "BOOL",
  "FUNCTION", "FUNC", "EXCEPTION", "RAISE", "TYPEDEF", "IMPORT", "NEW",
  "ANONINIT", "NAMESPACE", "PUBLIC", "PROTECTED", "EXTEND", "WHILE", "DO",
  "FOR", "SWITCH", "BREAK", "CONTINUE", "RETURNTOK", "FORK", "CASE",
  "DEFAULT", "TWIXT", "NAME", "TYPENAME", "NAMESPACENAME", "COMMAND",
  "NAMECOMMAND", "TEN_NUM", "OCTAL0_NUM", "OCTAL_NUM", "BINARY_NUM",
  "HEX_NUM", "TEN_FLOAT", "OCTAL0_FLOAT", "OCTAL_FLOAT", "BINARY_FLOAT",
  "HEX_FLOAT", "CHAR_CONST", "STRING_CONST", "POLY_CONST", "THREAD_CONST",
  "COMMENT_CONST", "VOIDVAL", "BOOLVAL", "DARROW", "ISTYPE", "HASMEMBER",
  "POUND", "COMMA", "ASSIGNAND", "ASSIGNOR", "ASSIGNLOR", "ASSIGNLAND",
  "ASSIGNLXOR", "ASSIGNSHIFTR", "ASSIGNSHIFTL", "ASSIGNPOW", "ASSIGNMOD",
  "ASSIGNDIV", "ASSIGNDIVIDE", "ASSIGNTIMES", "ASSIGNMINUS", "ASSIGNPLUS",
  "ASSIGN", "COLON", "QUEST", "OR", "AND", "LOR", "LXOR", "LAND", "NE",
  "EQ", "GE", "LE", "GT", "LT", "SHIFTR", "SHIFTL", "MINUS", "PLUS", "DIV",
  "DIVIDE", "TIMES", "POW3", "POW2", "STARSTAR", "POW", "UNIONCAST",
  "THREADID", "AMPER", "STAR", "DEC", "INC", "LNOT", "FACT", "BANG",
  "UMINUS", "CP", "OP", "CALL", "STAROS", "ARROW", "DOT", "CS", "OS",
  "POINTER", "COLONCOLON", "NONL", "TRY", "IF", "NL", "CATCH", "ELSE",
  "$accept", "lines", "pcommand", "eend", "ignorenl", "attendnl", "reset",
  "not_command", "opt_nl", "opt_semi", "opt_comma", "command",
  "opt_rawnames", "rawnames", "rawname", "rawatom", "rawnamespace",
  "fulltype", "fullname", "fullnames", "namespace", "namespacename",
  "namespace_start", "namespace_end", "block", "block_start", "block_end",
  "statements", "if_statement", "statement", "simple_statement", "$@1",
  "for_exprs", "try_body_statement", "try_statement", "catches", "catch",
  "opt_func_body", "func_body", "$@2", "block_or_expr", "union_or_enum",
  "see_comment", "doc_string", "opt_comment", "case_block", "cases",
  "case", "union_case_block", "union_cases", "union_case", "opt_name",
  "atoms", "typenames", "typename", "initnames", "name", "next_decl",
  "func_decl", "func_name", "opt_init", "decl", "subscripts", "type",
  "subtype", "opt_type", "basetype", "opt_stars", "stars", "dotdotdots",
  "dims", "struct_members", "union_members", "opt_class", "class",
  "opt_publish", "publish", "publish_extend", "opt_argdecls", "argdecls",
  "argdecl", "args", "opt_argdefines", "argdefines", "argdefine",
  "opt_dotdotdot", "opt_expr", "expr", "comma_expr", "opt_exprs", "exprs",
  "opt_actuals", "actuals", "func_right", "$@3", "simpleexpr",
  "opt_integer", "assignop", "integer", "opt_arrayinit", "arrayinit",
  "comprehension", "compnames", "compname", "comparray", "arrayelts",
  "arrayelt", "opt_hashinit", "hashinit", "hashelts", "hashelt",
  "hashvalue", "structinit", "structelts", "structelt", "init", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   151,   152,   152,   153,   153,   154,   154,   154,   155,
     156,   157,   158,   159,   159,   160,   160,   161,   161,   162,
     162,   162,   162,   162,   162,   162,   163,   163,   164,   164,
     165,   166,   166,   166,   167,   167,   168,   168,   169,   169,
     170,   170,   171,   171,   172,   172,   173,   174,   175,   176,
     177,   178,   178,   179,   179,   180,   180,   181,   181,   181,
     181,   181,   181,   181,   181,   181,   181,   181,   181,   181,
     181,   181,   181,   182,   181,   181,   181,   181,   183,   183,
     184,   184,   185,   186,   186,   187,   188,   188,   190,   189,
     191,   191,   192,   192,   193,   194,   195,   195,   196,   197,
     197,   198,   198,   199,   200,   200,   201,   201,   202,   202,
     203,   203,   204,   204,   205,   205,   206,   206,   207,   208,
     209,   210,   210,   210,   211,   211,   211,   212,   212,   212,
     213,   213,   213,   213,   213,   213,   214,   214,   214,   214,
     214,   214,   215,   215,   215,   215,   215,   215,   216,   216,
     217,   217,   217,   217,   217,   217,   217,   217,   217,   217,
     217,   217,   217,   218,   218,   219,   219,   220,   220,   221,
     221,   222,   222,   223,   223,   224,   224,   225,   225,   225,
     225,   226,   226,   227,   227,   228,   228,   229,   229,   230,
     230,   231,   231,   232,   233,   233,   234,   234,   235,   235,
     236,   236,   237,   237,   238,   238,   239,   239,   240,   240,
     241,   241,   242,   242,   243,   243,   244,   245,   244,   246,
     246,   246,   246,   246,   246,   246,   246,   246,   246,   246,
     246,   246,   246,   246,   246,   246,   246,   246,   246,   246,
     246,   246,   246,   246,   246,   246,   246,   246,   246,   246,
     246,   246,   246,   246,   246,   246,   246,   246,   246,   246,
     246,   246,   246,   246,   246,   246,   246,   246,   246,   246,
     246,   246,   246,   246,   246,   246,   246,   246,   246,   246,
     246,   246,   246,   246,   246,   246,   246,   246,   246,   246,
     246,   247,   247,   248,   248,   248,   248,   248,   248,   248,
     248,   248,   248,   248,   248,   248,   248,   248,   249,   249,
     249,   249,   249,   250,   250,   250,   251,   251,   252,   252,
     253,   253,   254,   255,   256,   256,   257,   257,   258,   258,
     258,   259,   260,   260,   261,   261,   262,   262,   263,   264,
     264,   265,   265,   265,   265,   266,   266,   266,   266
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     2,     0,     1,     3,     1,     1,     1,     0,
       0,     0,     0,     1,     0,     1,     0,     1,     0,     4,
       6,     4,     6,     6,     1,     1,     1,     0,     3,     1,
       2,     1,     1,     1,     3,     0,     2,     1,     2,     1,
       1,     3,     3,     2,     1,     1,     0,     0,     3,     2,
       2,     2,     0,     7,     9,     1,     1,     3,     9,    10,
       9,     9,    10,     2,     2,     3,     2,     1,     4,    10,
       6,     6,     7,     0,     9,     6,     2,    11,     3,     1,
       1,     3,     4,     2,     0,     7,     1,     1,     0,     2,
       1,     4,     1,     1,     0,     2,     1,     0,     3,     2,
       0,     4,     3,     3,     2,     0,     7,     3,     1,     0,
       3,     1,     3,     1,     1,     1,     4,     2,     1,     1,
       4,     3,     4,     4,     2,     2,     0,     4,     3,     2,
       2,     4,     4,     4,     4,     0,     2,     2,     2,     2,
       2,     3,     1,     4,     4,     4,     3,     1,     1,     0,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     0,     3,     1,     3,     1,     3,
       1,     4,     0,     4,     0,     1,     0,     1,     1,     1,
       1,     1,     0,     1,     1,     1,     1,     3,     2,     3,
       2,     2,     1,     3,     2,     1,     3,     2,     2,     1,
       1,     0,     1,     0,     1,     2,     1,     3,     1,     0,
       3,     1,     1,     0,     3,     2,     3,     0,     2,     3,
       7,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     3,     3,     3,     3,     3,
       3,     3,     2,     2,     3,     3,     5,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     2,     6,     8,     8,     8,     3,     6,
       2,     1,     3,     3,     4,     4,     4,     6,     6,     3,
       3,     1,     0,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     2,     0,     5,     9,     2,     1,
       3,     1,     1,     0,     3,     1,     1,     1,     1,     2,
       0,     4,     3,     1,     3,     2,     1,     1,     4,     3,
       1,     3,     3,     4,     4,     1,     1,     1,     2
};

/* YYDEFACT[STATE-NAME] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       3,     0,     1,    11,    25,    24,     2,   182,     4,     0,
       0,    92,    93,    67,     0,    46,   292,   177,   178,   179,
     180,   150,   151,   152,   153,   154,   162,   155,   156,   157,
     158,   159,   160,   161,     9,     0,   183,   184,   186,     9,
       9,     9,     9,     0,     0,   149,   149,     9,    44,    37,
      45,   209,    35,   259,   261,   260,   262,   263,   264,   266,
     265,   267,   268,   269,   270,   271,   272,     0,     0,   149,
     149,   149,   149,   149,   149,   149,   149,   149,   149,   281,
       0,     9,     9,   147,   258,     0,    39,    56,   182,    47,
      11,    55,    10,     0,    94,    46,     0,    14,   135,     0,
     142,   149,   185,   176,     0,    11,   204,   206,     7,     8,
       6,     5,   149,   149,     0,   308,   310,   309,   311,   312,
     221,    49,   280,   291,     0,     0,     0,    46,    46,    46,
      46,    63,    64,     0,     0,     0,   176,     0,   202,   148,
     234,    46,    43,    11,   208,   211,    11,    26,    29,     0,
     149,   149,   139,   225,   140,   224,   226,   137,   222,   138,
     223,   232,   230,   227,   228,   149,     0,    14,     0,   273,
     182,    46,    36,    45,    38,    47,   182,     0,    10,    14,
      76,     9,    97,    88,     9,     0,   118,   205,   126,     0,
       0,    13,   129,     0,   149,   136,   135,    46,     0,     0,
       0,     0,     0,     0,     0,   148,    14,     9,     9,     9,
     149,   175,     9,    66,   149,     0,   149,   149,   306,   305,
     304,   303,   302,   301,   300,   299,   298,   297,   296,   295,
     294,   293,   307,   149,   149,   149,   149,   149,   149,   149,
     149,   149,   149,   149,   149,   149,   149,   149,   149,   149,
     149,   149,   243,   242,   149,   233,   231,   229,   149,   149,
       0,     0,   149,   149,     0,     0,     0,     0,   111,     0,
       0,   149,     0,   182,     0,     0,   118,    65,     0,    16,
     149,    16,    35,    31,    33,    32,    30,     0,     0,   166,
     148,     0,     0,   170,   283,   146,     0,   282,   182,    80,
      84,     0,    42,     0,    48,    51,    57,    21,    46,    96,
      95,    87,    47,    86,    10,   149,     0,     0,   121,   149,
     117,   141,   278,   188,   192,     0,   201,   168,   148,     0,
     163,     0,     0,   130,     0,   139,   140,   137,   138,     0,
       0,   128,     0,     0,     0,    14,     0,    11,    19,   207,
     240,     0,   251,   250,   249,   247,   248,   253,   252,   257,
     256,   255,   254,   245,   244,   236,   235,   239,   238,   237,
     241,     0,   212,   201,     0,   290,   289,     0,   219,     0,
     143,     0,   144,     0,   145,   123,     0,   149,     0,   203,
     149,   149,    15,     0,   210,     0,    28,    34,     0,     0,
       0,     0,     0,     0,   149,     0,   278,     0,    82,   149,
      50,     0,    68,     0,    90,    89,   199,     0,   194,   201,
     120,   122,   149,   124,   345,   347,   346,   125,   119,     0,
     191,   187,   200,     0,   190,   135,   135,     0,   135,   135,
       9,    94,   146,    46,   115,    37,     0,   113,     0,    40,
       0,   127,    45,    73,     0,   149,   286,   149,   215,   284,
     285,   149,   149,   110,     0,     0,     0,     0,    79,     0,
       0,    22,    23,     0,     0,    46,   165,    46,    46,   169,
      47,   149,    81,     0,    83,     0,   149,   149,   198,   149,
     197,   348,    44,   149,   281,    46,   326,    18,   325,    18,
     333,    18,   340,   327,   116,   189,   134,   131,   167,   132,
     133,     0,    10,     0,    10,     0,   114,     0,     0,    10,
       0,    20,   246,   214,   171,   173,    70,   182,   149,   182,
     203,     0,   149,   287,   288,   330,     0,   315,   274,   279,
      46,   182,     0,     0,   196,   149,   336,   335,   337,     0,
       0,   149,    17,   201,    17,     0,    17,     0,   193,     0,
      47,     0,    47,    71,   112,    10,    41,    75,   182,    47,
       0,    47,    78,   100,    47,     0,   149,    47,   328,   149,
      47,   149,    47,   313,     0,    53,     0,    91,   341,   342,
     149,   322,   323,   321,   334,   326,   324,     0,     0,   332,
     331,     0,     0,   339,   338,   149,   220,   218,    94,    72,
       0,    10,    47,    10,   149,     0,    47,   100,    10,   182,
     329,   277,   275,   314,   276,    94,   182,   105,    47,   343,
     344,     0,     0,   316,   216,     0,    10,    58,    10,    60,
       0,   182,    98,    99,    61,    47,     0,    54,    46,     0,
      47,   105,    10,     0,   320,    10,    74,    59,   182,   102,
      10,    47,     0,   182,   103,   104,    62,   149,   319,    47,
      69,   101,    77,    85,   109,   107,   318,     0,   108,     0,
     317,   182,    47,   106
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     1,     6,   111,   315,   180,     9,     7,   192,   393,
     553,     8,   146,   147,   148,   286,   149,    83,    84,   450,
      85,    86,   121,   303,    87,    88,   304,   175,    89,   176,
      91,   520,   467,   300,    92,   408,   484,   312,   313,   314,
     415,    93,   182,   183,   310,   574,   616,   617,   628,   650,
     651,   679,   269,   446,   447,   187,   188,   429,    94,    95,
     320,    96,   195,   139,    98,    99,   100,   329,   291,   331,
     292,   265,   267,   210,   101,   102,   103,   104,   196,   325,
     326,   441,   316,   418,   419,   434,   468,   177,   106,   143,
     144,   371,   372,   560,   561,   107,   122,   263,   120,   582,
     424,   669,   592,   593,   631,   497,   498,   577,   425,   499,
     500,   547,   426,   501,   502,   503
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -571
static const yytype_int16 yypact[] =
{
    -571,   743,  -571,  -571,  -571,  -571,  -571,  1059,  -571,     4,
      22,    63,    65,  -571,   106,  -571,   106,  -571,  -571,  -571,
    -571,  -571,  -571,  -571,  -571,  -571,  -571,  -571,  -571,  -571,
    -571,  -571,  -571,  -571,  -571,    24,  -571,  -571,  -571,  -571,
    -571,  -571,  -571,    78,   112,  1607,  3834,  -571,  -571,  -571,
     -27,  3048,     0,  -571,  -571,  -571,  -571,  -571,  -571,  -571,
    -571,  -571,  -571,  -571,  -571,  -571,  -571,    11,    21,  3834,
    3834,  3834,  3834,  3834,  3834,  3834,  3834,  3834,  1738,  -571,
      39,  -571,  -571,  -571,  -571,    90,  -571,  -571,  1196,  -571,
    -571,  -571,  -571,    83,  -571,  -571,    50,    -4,   -63,   147,
    -571,  4860,    80,   283,   123,    17,   148,  4365,  -571,  -571,
    -571,  -571,   333,  4614,   175,  -571,  -571,  -571,  -571,  -571,
    -571,  -571,  -571,  -571,   186,   111,   118,  -571,  -571,  -571,
    -571,  -571,  -571,    63,    65,   190,   122,   240,  -571,   -29,
    4420,  -571,  -571,  -571,  -571,  4015,  -571,  -571,   170,   145,
    3834,  3834,  -571,    26,  -571,    26,    26,  -571,    26,  -571,
      26,    26,    26,    26,    26,  3179,   125,   -13,   132,  -571,
    1333,  -571,  -571,   127,  -571,  -571,   922,   258,  -571,   124,
    -571,  -571,   195,   264,  -571,   218,   149,  -571,   183,  4860,
     225,  -571,  -571,  4654,  2393,  -571,   -63,  -571,   -27,  4860,
    4860,  4860,  4860,  4860,    68,   169,   124,  -571,  -571,  -571,
    4860,  -571,  -571,  -571,  2131,   140,  3834,  3834,  -571,  -571,
    -571,  -571,  -571,  -571,  -571,  -571,  -571,  -571,  -571,  -571,
    -571,  -571,  -571,  3834,  3834,  3834,  3834,  3834,  3834,  3834,
    3834,  3834,  3834,  3834,  3834,  3834,  3834,  3834,  3834,  3834,
    3834,  3834,  -571,  -571,  3834,  -571,  -571,  -571,  3310,  3834,
     230,   231,  3834,  3834,   175,   279,   175,   293,   226,   296,
     177,  3441,   181,  1470,   184,   189,  -571,  -571,   192,   308,
    3834,   308,  -571,  -571,  -571,  -571,   185,  4073,  4131,  3048,
     -33,   -25,   191,  4189,  -571,   317,   272,  -571,  1196,  -571,
    -571,   197,  -571,   320,  -571,  -571,  -571,  -571,  -571,  -571,
    -571,  -571,  -571,  -571,   322,  4737,   202,   206,  -571,  3572,
     253,  -571,  -571,  -571,     2,   208,    27,  -571,    13,   203,
     260,   -16,   205,  -571,   221,  -571,  -571,  -571,  -571,   -35,
     127,  -571,   295,  4777,    24,   124,   130,  -571,  -571,  4365,
     277,  4246,  4477,   901,  1038,  1175,  1312,   547,   547,   713,
     713,   713,   713,  1443,  1443,   176,   176,   277,   277,   277,
     277,   234,  -571,  3957,   229,  -571,  -571,   237,  4365,   361,
    -571,   368,  -571,   175,  -571,  -571,   246,  2131,   339,  1869,
    2131,  1607,  -571,   244,  -571,   257,  -571,  -571,  4860,   342,
     274,   291,   285,   286,  3834,   399,   287,   400,   269,  2131,
    -571,   289,  -571,   323,  -571,  -571,     9,   369,  -571,    29,
    -571,  -571,  2262,  4365,  -571,  -571,  -571,  -571,  -571,   190,
    -571,  -571,  -571,  4860,  -571,   -63,   -63,   411,   -63,   -63,
    -571,  -571,  -571,  -571,  -571,    14,   418,   345,   -30,   346,
     421,  -571,  -571,  -571,   294,  3834,  -571,  3834,  -571,  -571,
    -571,   333,  4614,  -571,   422,   299,   303,   300,   430,   309,
     432,  -571,  -571,    -2,   310,  -571,  -571,  -571,  -571,  -571,
    -571,  3834,  -571,    24,  -571,   312,  2131,  3834,  -571,  4860,
    -571,  -571,   349,  3572,   391,    39,  4308,   367,  -571,   372,
    -571,   373,  -571,  -571,  -571,  -571,  -571,  -571,  -571,  -571,
    -571,   325,   448,   327,  -571,   101,  -571,   453,    24,  -571,
     454,  -571,  4420,  -571,  -571,  -571,  -571,  1470,  2131,  1470,
    1869,   322,  2000,  -571,  -571,   457,   458,   460,  -571,    26,
    -571,  1470,   331,  3899,  -571,  3572,  4365,  -571,  -571,   375,
     417,  3572,  2524,   462,  2655,   466,   -49,   467,  -571,   383,
    -571,   322,  -571,  -571,  -571,  -571,  -571,  -571,  1196,  -571,
     352,  -571,  -571,   152,  -571,   354,  2786,  -571,  -571,  3703,
    -571,  2917,  -571,  -571,   221,   347,   322,  -571,  4365,  -571,
    3572,  -571,  -571,   414,  -571,  4365,  -571,   482,  4308,  -571,
    -571,   349,   391,  -571,  -571,  3834,  -571,  -571,  -571,  -571,
     488,  -571,  -571,  -571,  2131,   402,  -571,   152,  -571,  1470,
    -571,  -571,  -571,  -571,  -571,  -571,  1470,   154,  -571,  4365,
    -571,   364,   417,  -571,  4365,   496,  -571,  -571,  -571,  -571,
     407,   922,  -571,  -571,  -571,  -571,   322,  -571,  -571,   408,
    -571,   154,  -571,    10,  -571,  -571,  -571,  -571,   922,  -571,
    -571,  -571,   451,   922,  -571,  -571,  -571,  3572,  -571,  -571,
    -571,  -571,  -571,  -571,   452,  -571,  -571,   498,  -571,   412,
    -571,   922,  -571,  -571
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -571,  -571,  -571,  -571,    56,    60,   -71,  -571,  -167,   236,
    -300,  -571,  -571,   233,  -571,  -571,  -571,  -571,   -18,    19,
     442,   -84,   151,   -76,   -73,  -494,  -570,  -117,  -571,     1,
     370,  -571,   -11,  -571,  -571,  -571,  -571,  -571,  -571,  -571,
    -571,  -571,  -571,  -423,  -571,  -571,   -79,  -571,  -571,  -112,
    -571,  -571,  -244,  -422,  -571,   115,  -571,  -571,  -571,  -571,
    -571,   -38,  -182,    -7,  -571,   -65,  -571,  -571,   351,  -571,
    -192,    86,    87,  -571,   -62,  -571,   -14,  -571,    35,   117,
    -571,   -31,   116,    62,  -571,  -370,   -41,    -1,  -571,   292,
     278,  -571,   108,  -571,  -571,   -19,  -571,  -571,   550,  -571,
    -278,  -571,   -64,  -571,  -571,  -571,  -543,  -571,    32,  -571,
      16,    30,  -571,  -571,    28,  -303
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -218
static const yytype_int16 yytable[] =
{
      97,   174,   332,   458,   137,   166,   105,   135,    90,   596,
     601,   -27,   307,   178,   333,   108,   427,   125,   512,   179,
     379,   109,   381,    15,  -148,  -114,   517,   140,   213,   444,
     516,   136,   145,  -148,   215,   112,   206,   573,    97,   341,
     135,   211,   174,   432,   138,   432,   642,   264,   266,   490,
     153,   155,   156,   158,   160,   161,   162,   163,   164,   305,
     401,   430,   152,   154,   136,   157,   159,   374,  -148,   437,
     377,   167,   279,   193,   211,   281,   113,   168,   114,   194,
     664,    97,   189,    48,   189,    50,   185,   189,   189,   131,
     124,   602,   627,   564,   205,   127,   128,   129,   130,  -114,
     442,   214,   480,   141,   189,   205,   205,   190,   400,   186,
     667,   190,   433,   189,   489,   189,   402,   142,   207,   189,
     208,   209,   295,   132,   676,   438,   189,   296,   172,   340,
     189,   287,   288,   533,   181,   191,   190,   170,   171,   463,
      17,    18,    19,    20,   191,   345,   293,   150,   -27,    48,
     172,   173,   110,   190,   435,   255,   256,   151,   290,   257,
     444,   516,   258,    97,   259,   260,   261,   212,   262,    97,
     115,   116,   117,   118,   119,   293,   135,    48,   451,   173,
     169,   407,   321,   597,   197,   635,   324,   328,   217,    48,
     548,   452,   335,   336,   337,   338,   339,   349,   350,   555,
     136,   557,   646,   205,   283,   284,   285,    97,   614,   615,
     648,   649,   479,   347,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   216,   268,   370,   412,   308,   306,   373,
     293,   414,   589,   293,   378,   270,   184,   271,   548,   276,
     417,   277,   145,   506,   507,   282,   509,   510,   580,   583,
     294,   145,   453,   342,   343,   344,    97,   297,   346,   213,
     158,   302,   191,   309,   388,   311,   454,   317,   272,   273,
     274,   275,   157,   319,   322,   318,   189,   630,   348,   375,
     376,    97,   278,   380,   249,   250,   251,   252,   253,   254,
     423,    17,    18,    19,    20,   255,   256,   382,   416,   257,
     384,   383,   258,   385,   259,   260,   261,   387,   262,   392,
     389,  -181,   301,  -181,  -181,   390,   449,  -181,   391,   397,
     -46,   406,   403,   409,   410,    15,   448,   420,   428,    10,
     133,   134,   421,   431,   436,   401,   439,  -172,   334,   135,
     470,   135,   135,   135,   443,    21,    22,   440,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,   456,
     459,   135,   461,   136,   413,   136,   136,   136,   460,   462,
      97,   464,    97,    97,    97,   293,   465,   466,   138,   469,
     138,   473,   471,    49,   198,   136,   264,   266,   252,   253,
     254,   474,    97,   496,   538,   472,   255,   256,   485,   475,
     257,   476,   422,   258,   482,   259,   260,   261,   483,   262,
     477,   478,   481,   487,   417,   486,   324,   508,   488,   514,
     515,   518,   519,   526,   527,   529,   522,   199,   373,   528,
     200,   530,   521,   532,   531,   534,   405,   541,   135,   545,
     549,   610,   552,   201,   205,   205,   202,   554,   556,   411,
     558,  -217,   539,   193,   565,   540,   586,   568,   543,   203,
     576,   579,   136,   581,   546,   590,   591,   126,   432,    97,
     600,   604,   416,   605,   606,   542,   608,   612,   607,   619,
     135,   575,   135,   611,   135,   613,   633,   626,   618,   632,
     449,   621,   636,   641,   622,   653,   624,   655,   658,   663,
     674,   678,   680,   681,   136,   396,   136,   395,   136,   572,
      97,    97,    97,    97,   659,    97,   588,   570,   569,   138,
     571,   138,   546,   595,    97,   598,   638,   566,   643,   665,
     299,   671,   585,   204,   504,   330,   675,   524,   562,   525,
     505,   544,   652,   625,   204,   204,   511,   598,   394,   217,
     595,    97,   595,   386,   682,   523,   123,   578,   654,   660,
     599,   629,   559,   661,   563,     0,   135,     0,     0,   567,
     668,   594,     0,     0,   603,   673,   634,     0,     0,     0,
       0,     0,     0,   677,   513,     0,     0,     0,     0,     0,
     136,     0,     0,     0,     0,     0,   683,    97,     0,     0,
       0,     0,    97,   640,     0,     0,     0,     0,     0,    97,
     645,     0,     0,     0,     0,   609,   535,   647,   536,   537,
       0,   204,     0,     0,    97,   204,     0,     0,     0,     0,
       0,   204,   204,   204,   204,   204,   550,     0,   595,     0,
       0,    97,   204,     0,     0,     0,    97,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   637,     0,   639,    97,     0,   255,   256,   644,     0,
     257,     0,     0,   258,     0,   259,   260,   261,     0,   262,
       0,   584,     0,     0,     0,     0,   656,     0,   657,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   666,     0,     0,   670,     0,     0,     0,     0,
     672,     0,     0,     0,     0,   217,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     2,     3,     0,     0,     0,     0,   -12,
     -12,   -12,     0,     0,   -12,   -12,   -12,   204,   -12,     0,
       4,   -12,   -12,   -12,   -12,   -12,   -12,     0,   -12,   -12,
     -12,   -12,   -12,   -12,   -12,   -12,   -12,   -12,   -12,   -12,
     -12,   -12,   -12,   -12,   -12,   204,   126,   -12,   -12,   -12,
     -12,   -12,   -12,   -12,   -12,   -12,   -12,   -12,   -12,   662,
       0,   -12,   -12,   -12,   -12,   -12,   -12,   -12,   -12,   -12,
     -12,   -12,   -12,   -12,   -12,   -12,   -12,   -12,   -12,     0,
       0,     0,   -12,   -12,     0,   -12,   -12,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,     0,     0,     0,
     204,     0,   255,   256,     0,     0,   257,   -12,     0,   258,
     -12,   259,   260,   261,     0,   262,     0,     0,     0,   -12,
       0,     0,     0,   -12,     0,     0,   -12,     0,     0,     0,
       0,     0,   -12,   -12,   -12,   204,   -12,     0,     0,   -12,
       0,     0,     0,   -12,     0,   -12,     0,     0,     0,   -12,
     -12,     5,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   204,   204,     0,     0,     0,     0,     0,
       0,     0,     0,   217,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   126,     0,     0,    10,    11,
      12,   204,     0,    13,    14,    15,   -52,    16,     0,     0,
      17,    18,    19,    20,    21,    22,     0,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,  -149,
     126,    35,     0,     0,     0,     0,     0,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,   -52,   -52,
      47,    48,    49,    50,     0,     0,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,     0,     0,
       0,    65,    66,     0,    67,    68,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,     0,    69,     0,     0,    70,
     255,   256,     0,     0,   257,     0,     0,   258,    71,   259,
     260,   261,    72,   262,     0,    73,     0,     0,     0,     0,
     217,    74,    75,    76,     0,    77,     0,     0,    78,     0,
       0,     0,    79,     0,    80,    10,    11,    12,    81,    82,
      13,    14,    15,     0,    16,     0,     0,    17,    18,    19,
      20,    21,    22,     0,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,  -149,     0,    35,     0,
       0,     0,     0,     0,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,     0,     0,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,     0,     0,     0,    65,    66,
       0,    67,    68,     0,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,     0,    69,     0,     0,    70,   255,   256,     0,
       0,   257,     0,     0,   258,    71,   259,   260,   261,    72,
     262,     0,    73,     0,     0,     0,     0,   217,    74,    75,
      76,     0,    77,     0,     0,    78,     0,     0,     0,    79,
       0,    80,    10,    11,    12,    81,    82,    13,    14,    15,
     -52,    16,     0,     0,    17,    18,    19,    20,    21,    22,
       0,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,  -149,     0,    35,     0,     0,     0,     0,
       0,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,     0,     0,    47,    48,    49,    50,     0,     0,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,     0,     0,     0,    65,    66,     0,    67,    68,
       0,     0,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,     0,
      69,     0,     0,    70,   255,   256,     0,     0,   257,     0,
       0,   258,    71,   259,   260,   261,    72,   262,     0,    73,
       0,     0,     0,     0,   217,    74,    75,    76,     0,    77,
       0,     0,    78,     0,     0,     0,    79,     0,    80,    10,
      11,    12,    81,    82,    13,    14,   298,     0,    16,     0,
       0,    17,    18,    19,    20,    21,    22,     0,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
    -149,     0,    35,     0,     0,     0,     0,     0,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,     0,
       0,    47,    48,    49,    50,     0,     0,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,     0,
       0,     0,    65,    66,     0,    67,    68,     0,     0,     0,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,     0,    69,     0,     0,
      70,   255,   256,     0,     0,   257,     0,     0,   258,    71,
     259,   260,   261,    72,   262,   217,    73,     0,     0,     0,
       0,     0,    74,    75,    76,     0,    77,     0,     0,    78,
       0,     0,     0,    79,     0,    80,    10,    11,    12,    81,
      82,    13,    14,    15,     0,    16,     0,     0,    17,    18,
      19,    20,    21,    22,     0,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,  -149,     0,    35,
       0,     0,     0,     0,     0,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,     0,     0,    47,    48,
      49,    50,     0,     0,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,     0,     0,     0,    65,
      66,     0,    67,    68,     0,     0,     0,     0,     0,   247,
     248,   249,   250,   251,   252,   253,   254,     0,     0,     0,
       0,     0,   255,   256,    69,     0,   257,    70,     0,   258,
       0,   259,   260,   261,     0,   262,    71,     0,     0,     0,
      72,     0,     0,    73,     0,     0,     0,     0,     0,    74,
      75,    76,     0,    77,     0,     0,    78,     0,     0,     0,
      79,     0,    80,    10,   133,   134,    81,    82,  -203,    14,
       0,     0,    16,     0,     0,    17,    18,    19,    20,    21,
      22,     0,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    36,    37,     0,     0,     0,     0,     0,     0,
       0,     0,    46,     0,     0,     0,    48,    49,    50,     0,
       0,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,     0,     0,     0,    65,    66,     0,    67,
      68,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    69,     0,     0,    70,     0,     0,     0,     0,     0,
       0,     0,     0,    71,     0,     0,     0,    72,     0,     0,
      73,     0,     0,     0,     0,     0,    74,    75,    76,     0,
      77,     0,     0,    78,    10,   133,   134,    79,     0,    80,
      14,    15,     0,    16,     0,     0,    17,    18,    19,    20,
      21,    22,     0,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    36,    37,     0,     0,     0,     0,     0,
       0,     0,     0,    46,     0,     0,     0,    48,    49,    50,
       0,     0,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,     0,     0,     0,    65,    66,     0,
      67,    68,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    69,     0,     0,    70,     0,     0,     0,     0,
       0,     0,     0,     0,    71,     0,     0,     0,    72,     0,
       0,    73,     0,     0,     0,     0,     0,    74,    75,    76,
       0,    77,     0,     0,    78,    10,   133,   134,    79,     0,
     165,    14,     0,     0,    16,     0,     0,    17,    18,    19,
      20,    21,    22,     0,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,     0,  -149,     0,     0,     0,
       0,     0,     0,     0,    36,    37,     0,     0,     0,     0,
       0,     0,     0,     0,    46,     0,     0,     0,    48,    49,
      50,     0,     0,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,     0,     0,     0,    65,    66,
       0,    67,    68,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    69,     0,     0,    70,     0,     0,     0,
       0,     0,     0,     0,     0,    71,     0,     0,     0,    72,
       0,     0,    73,     0,     0,     0,     0,     0,    74,    75,
      76,     0,    77,     0,     0,    78,    10,   133,   134,    79,
       0,    80,    14,     0,     0,    16,     0,     0,    17,    18,
      19,    20,    21,    22,     0,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    36,    37,     0,     0,     0,
       0,     0,     0,     0,     0,    46,     0,     0,     0,    48,
      49,    50,     0,     0,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,     0,     0,     0,    65,
      66,     0,    67,    68,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    69,     0,     0,    70,     0,     0,
       0,     0,     0,     0,     0,     0,    71,     0,     0,     0,
      72,     0,     0,    73,     0,     0,     0,     0,     0,    74,
      75,    76,     0,    77,     0,  -203,    78,    10,   133,   134,
      79,     0,    80,    14,     0,     0,    16,     0,     0,    17,
      18,    19,    20,    21,    22,     0,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    36,    37,     0,     0,
       0,     0,     0,     0,     0,     0,    46,     0,     0,     0,
      48,    49,    50,     0,     0,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,     0,     0,     0,
      65,    66,     0,    67,    68,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    69,     0,     0,    70,     0,
       0,     0,     0,     0,     0,     0,     0,    71,     0,     0,
       0,    72,     0,     0,    73,     0,     0,     0,     0,     0,
      74,    75,    76,     0,    77,     0,     0,    78,    10,   133,
     134,    79,     0,    80,    14,   422,   491,    16,     0,     0,
       0,     0,     0,     0,    21,    22,     0,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    46,     0,     0,
       0,   492,    49,    50,     0,     0,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,     0,     0,
       0,    65,    66,   493,    67,    68,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    69,     0,     0,    70,
       0,     0,     0,     0,     0,     0,     0,     0,    71,     0,
       0,     0,    72,     0,     0,    73,     0,     0,     0,     0,
       0,    74,    75,    76,     0,    77,     0,     0,    78,    10,
     133,   134,   494,     0,   495,    14,     0,     0,    16,   327,
       0,     0,     0,     0,     0,    21,    22,     0,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    46,     0,
       0,     0,    48,    49,    50,     0,     0,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,     0,
       0,     0,    65,    66,     0,    67,    68,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    69,     0,     0,
      70,     0,     0,     0,     0,     0,     0,     0,     0,    71,
       0,     0,     0,   289,     0,     0,    73,     0,     0,     0,
       0,     0,    74,    75,    76,     0,    77,     0,     0,    78,
      10,   133,   134,    79,  -164,    80,    14,   422,     0,    16,
       0,     0,     0,     0,     0,     0,    21,    22,     0,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
       0,  -149,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    46,
       0,     0,     0,    48,    49,    50,     0,     0,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
       0,     0,     0,    65,    66,     0,    67,    68,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    69,     0,
       0,    70,     0,     0,     0,     0,     0,     0,     0,     0,
      71,     0,     0,     0,    72,     0,     0,    73,     0,     0,
       0,     0,     0,    74,    75,    76,     0,    77,     0,     0,
      78,    10,   133,   134,    79,     0,    80,    14,     0,     0,
      16,     0,     0,     0,     0,     0,     0,    21,    22,     0,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,     0,  -149,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      46,     0,     0,     0,    48,    49,    50,     0,     0,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,     0,     0,     0,    65,    66,   493,    67,    68,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    69,
       0,     0,    70,     0,     0,     0,     0,     0,     0,     0,
       0,    71,     0,     0,     0,    72,     0,     0,    73,     0,
       0,     0,     0,     0,    74,    75,    76,     0,    77,     0,
       0,    78,    10,   133,   134,    79,     0,    80,    14,     0,
     620,    16,     0,     0,     0,     0,     0,     0,    21,    22,
       0,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    46,     0,     0,     0,    48,    49,    50,     0,     0,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,     0,     0,     0,    65,    66,   493,    67,    68,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      69,     0,     0,    70,     0,     0,     0,     0,     0,     0,
       0,     0,    71,     0,     0,     0,    72,     0,     0,    73,
       0,     0,     0,     0,     0,    74,    75,    76,     0,    77,
       0,     0,    78,    10,   133,   134,    79,     0,    80,    14,
     422,   623,    16,     0,     0,     0,     0,     0,     0,    21,
      22,     0,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    46,     0,     0,     0,    48,    49,    50,     0,
       0,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,     0,     0,     0,    65,    66,     0,    67,
      68,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    69,     0,     0,    70,     0,     0,     0,     0,     0,
       0,     0,     0,    71,     0,     0,     0,    72,     0,     0,
      73,     0,     0,     0,     0,     0,    74,    75,    76,     0,
      77,     0,     0,    78,    10,   133,   134,    79,     0,   495,
      14,     0,     0,    16,     0,     0,     0,     0,     0,     0,
      21,    22,     0,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,     0,  -149,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    46,     0,     0,     0,    48,    49,    50,
       0,     0,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,     0,     0,     0,    65,    66,     0,
      67,    68,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    69,     0,     0,    70,     0,     0,     0,     0,
       0,     0,     0,     0,    71,     0,     0,     0,    72,     0,
       0,    73,     0,     0,     0,     0,     0,    74,    75,    76,
       0,    77,     0,     0,    78,    10,   133,   134,    79,     0,
      80,    14,     0,     0,    16,     0,     0,     0,     0,     0,
       0,    21,    22,     0,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    46,     0,     0,     0,    48,    49,
      50,     0,     0,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,     0,     0,     0,    65,    66,
       0,    67,    68,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    69,     0,     0,    70,     0,     0,     0,
       0,     0,     0,     0,     0,    71,     0,     0,     0,   289,
       0,     0,    73,     0,     0,     0,     0,     0,    74,    75,
      76,     0,    77,     0,     0,    78,    10,   133,   134,    79,
     169,    80,    14,     0,     0,    16,     0,     0,     0,     0,
       0,     0,    21,    22,     0,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    46,     0,     0,     0,    48,
      49,    50,     0,     0,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,     0,     0,     0,    65,
      66,     0,    67,    68,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    69,     0,     0,    70,     0,     0,
       0,     0,     0,     0,     0,     0,    71,     0,     0,     0,
      72,     0,     0,    73,     0,     0,     0,     0,     0,    74,
      75,    76,     0,    77,     0,  -213,    78,    10,   133,   134,
      79,     0,    80,    14,     0,     0,    16,     0,     0,     0,
       0,     0,     0,    21,    22,     0,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    46,     0,     0,     0,
      48,    49,    50,     0,     0,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,     0,     0,     0,
      65,    66,     0,    67,    68,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    69,     0,     0,    70,     0,
       0,     0,     0,     0,     0,     0,     0,    71,     0,     0,
       0,    72,     0,     0,    73,     0,     0,     0,     0,     0,
      74,    75,    76,     0,    77,     0,  -209,    78,    10,   133,
     134,    79,     0,    80,    14,   422,     0,    16,     0,     0,
       0,     0,     0,     0,    21,    22,     0,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    46,     0,     0,
       0,    48,    49,    50,     0,     0,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,     0,     0,
       0,    65,    66,     0,    67,    68,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    69,     0,     0,    70,
       0,     0,     0,     0,     0,     0,     0,     0,    71,     0,
       0,     0,    72,     0,     0,    73,     0,     0,     0,     0,
       0,    74,    75,    76,     0,    77,     0,     0,    78,    10,
     133,   134,    79,     0,    80,    14,   422,     0,    16,     0,
       0,     0,     0,     0,     0,    21,    22,     0,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    46,     0,
       0,     0,    48,    49,    50,     0,     0,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,     0,
       0,     0,    65,    66,     0,    67,    68,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    69,     0,     0,
      70,     0,     0,     0,     0,     0,     0,     0,     0,    71,
       0,     0,     0,    72,     0,     0,    73,     0,     0,     0,
       0,     0,    74,    75,    76,     0,    77,     0,     0,    78,
      10,   133,   134,    79,     0,   495,    14,     0,     0,    16,
       0,     0,     0,     0,     0,     0,    21,    22,     0,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    46,
       0,     0,     0,    48,    49,    50,     0,     0,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
     587,   217,     0,    65,    66,     0,    67,    68,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    69,     0,
       0,    70,     0,     0,     0,     0,     0,     0,     0,     0,
      71,     0,     0,     0,    72,     0,     0,    73,     0,     0,
       0,     0,     0,    74,    75,    76,     0,    77,     0,   217,
      78,     0,     0,   432,    79,     0,    80,     0,     0,     0,
       0,     0,     0,     0,     0,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
       0,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,     0,     0,     0,     0,   217,   255,   256,
       0,     0,   257,     0,     0,   258,     0,   259,   260,   261,
       0,   262,   457,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,     0,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,     0,     0,     0,     0,   217,   255,   256,     0,     0,
     257,     0,     0,   258,     0,   259,   260,   261,     0,   262,
     280,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,     0,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,     0,
       0,     0,     0,   217,   255,   256,     0,     0,   257,     0,
       0,   258,     0,   259,   260,   261,     0,   262,   398,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,     0,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,     0,     0,     0,
       0,   217,   255,   256,     0,     0,   257,     0,     0,   258,
       0,   259,   260,   261,     0,   262,   399,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,     0,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,     0,     0,     0,   217,     0,
     255,   256,     0,     0,   257,     0,     0,   258,     0,   259,
     260,   261,     0,   262,   404,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
       0,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,     0,     0,     0,     0,     0,   255,   256,
     217,     0,   257,     0,     0,   258,     0,   259,   260,   261,
       0,   262,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   455,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
       0,     0,     0,     0,     0,   255,   256,   217,     0,   257,
       0,     0,   258,     0,   259,   260,   261,     0,   262,   551,
       0,     0,     0,     0,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,     0,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   217,     0,     0,     0,     0,   255,   256,     0,
       0,   257,     0,     0,   258,     0,   259,   260,   261,     0,
     262,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,     0,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   217,
       0,     0,     0,     0,   255,   256,     0,     0,   257,     0,
       0,   258,     0,   259,   260,   261,     0,   262,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,     0,     0,     0,     0,     0,   255,
     256,     0,     0,   257,     0,     0,   258,     0,   259,   260,
     261,     0,   262,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,     0,     0,     0,     0,     0,   255,   256,     0,     0,
     257,     0,     0,   258,     0,   259,   260,   261,     0,   262,
      10,   133,   134,     0,     0,     0,     0,     0,  -174,     0,
       0,     0,     0,     0,     0,     0,    21,    22,     0,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      10,   133,   134,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    49,   198,    21,    22,     0,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    49,   198,     0,     0,   199,     0,
       0,   200,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   201,     0,     0,   202,     0,     0,
       0,     0,     0,    10,   133,   134,     0,     0,     0,     0,
     203,     0,     0,     0,     0,     0,     0,     0,   199,    21,
      22,   200,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,     0,   201,     0,     0,   202,     0,     0,
       0,     0,     0,    10,   133,   134,     0,     0,     0,   323,
     203,     0,     0,     0,     0,     0,     0,    49,   198,    21,
      22,     0,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   444,   445,   198,     0,
       0,   199,     0,     0,   200,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   201,     0,     0,
     202,     0,     0,     0,     0,     0,    10,   133,   134,     0,
       0,     0,  -195,   203,     0,     0,     0,     0,     0,     0,
       0,   199,    21,    22,   200,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,     0,   201,     0,     0,
     202,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   203,     0,     0,     0,     0,     0,     0,
      49,   198,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   199,     0,     0,   200,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     201,     0,     0,   202,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   203
};

#define yypact_value_is_default(yystate) \
  ((yystate) == (-571))

#define yytable_value_is_error(yytable_value) \
  YYID (0)

static const yytype_int16 yycheck[] =
{
       7,    85,   194,   373,    45,    78,     7,    45,     7,   552,
      59,    11,   179,    89,   196,    11,   319,    35,   441,    90,
     264,    17,   266,    13,    37,    11,   448,    46,    11,    59,
      60,    45,    51,    37,   105,    13,   101,   531,    45,   206,
      78,   103,   126,    16,    45,    16,   616,   112,   113,   419,
      69,    70,    71,    72,    73,    74,    75,    76,    77,   176,
      85,    59,    69,    70,    78,    72,    73,   259,    59,    85,
     262,    78,   143,   136,   136,   146,    13,    78,    13,   142,
     650,    88,   117,    59,   117,    61,    36,   117,   117,    11,
      34,   140,   586,   515,   101,    39,    40,    41,    42,    85,
     135,    84,   405,    47,   117,   112,   113,   140,   141,    59,
     100,   140,    85,   117,    85,   117,   141,   144,    38,   117,
      40,    41,   135,    11,   667,   141,   117,   140,    60,    61,
     117,   150,   151,   135,    51,   148,   140,    81,    82,   383,
      18,    19,    20,    21,   148,   210,   165,   136,   148,    59,
      60,    61,   148,   140,   141,   129,   130,   136,   165,   133,
      59,    60,   136,   170,   138,   139,   140,    44,   142,   176,
      64,    65,    66,    67,    68,   194,   214,    59,   345,    61,
     141,   298,   189,   553,    37,   608,   193,   194,    12,    59,
     493,    61,   199,   200,   201,   202,   203,   216,   217,   499,
     214,   501,   625,   210,    59,    60,    61,   214,    56,    57,
      56,    57,   404,   214,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,    85,    59,   254,   312,   181,   178,   258,
     259,   314,   545,   262,   263,    59,    95,   136,   551,    59,
     315,    11,   271,   435,   436,    85,   438,   439,   536,   537,
     135,   280,   346,   207,   208,   209,   273,   135,   212,    11,
     289,   144,   148,    78,   273,    11,   347,    59,   127,   128,
     129,   130,   289,   100,    59,   136,   117,   590,   148,    59,
      59,   298,   141,    14,   118,   119,   120,   121,   122,   123,
     319,    18,    19,    20,    21,   129,   130,    14,   315,   133,
      14,    85,   136,   136,   138,   139,   140,   136,   142,    11,
     136,    38,   171,    40,    41,   136,   344,    44,   136,   144,
      13,    59,   141,   136,    14,    13,   343,   135,    85,     6,
       7,     8,   136,   135,   141,    85,   141,    14,   197,   387,
     391,   389,   390,   391,    59,    22,    23,   136,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,   135,
     141,   409,    11,   387,   314,   389,   390,   391,   141,    11,
     387,   135,   389,   390,   391,   404,   387,    48,   389,   390,
     391,   398,   148,    60,    61,   409,   461,   462,   121,   122,
     123,    59,   409,   422,   480,   148,   129,   130,   409,   135,
     133,   120,    13,   136,    14,   138,   139,   140,   149,   142,
     135,   135,   135,   100,   489,   136,   433,    16,    59,    11,
      85,    85,    11,    11,   135,   135,   455,   104,   457,   136,
     107,    11,   148,    11,   135,   135,   295,   135,   486,   100,
      59,   568,    85,   120,   461,   462,   123,    85,    85,   308,
     135,    13,   481,   136,    11,   483,   135,    13,   487,   136,
      13,    13,   486,    13,   493,   100,    59,    35,    16,   486,
      14,    14,   489,   100,   560,   486,   562,   135,   561,   135,
     528,   532,   530,   569,   532,   571,    14,   150,   574,    85,
     518,   577,    14,   101,   580,   141,   582,    11,   101,   101,
      59,    59,    14,   101,   528,   282,   530,   281,   532,   530,
     527,   528,   529,   530,   641,   532,   545,   528,   527,   530,
     529,   532,   551,   552,   541,   554,   612,   518,   617,   651,
     170,   658,   541,   101,   429,   194,   663,   461,   513,   462,
     433,   489,   628,   584,   112,   113,   440,   576,   280,    12,
     579,   568,   581,   271,   681,   457,    16,   535,   632,   645,
     554,   590,   512,   646,   514,    -1,   614,    -1,    -1,   519,
     653,   551,    -1,    -1,   556,   661,   605,    -1,    -1,    -1,
      -1,    -1,    -1,   669,   443,    -1,    -1,    -1,    -1,    -1,
     614,    -1,    -1,    -1,    -1,    -1,   682,   614,    -1,    -1,
      -1,    -1,   619,   614,    -1,    -1,    -1,    -1,    -1,   626,
     619,    -1,    -1,    -1,    -1,   565,   475,   626,   477,   478,
      -1,   189,    -1,    -1,   641,   193,    -1,    -1,    -1,    -1,
      -1,   199,   200,   201,   202,   203,   495,    -1,   667,    -1,
      -1,   658,   210,    -1,    -1,    -1,   663,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
     123,   611,    -1,   613,   681,    -1,   129,   130,   618,    -1,
     133,    -1,    -1,   136,    -1,   138,   139,   140,    -1,   142,
      -1,   540,    -1,    -1,    -1,    -1,   636,    -1,   638,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   652,    -1,    -1,   655,    -1,    -1,    -1,    -1,
     660,    -1,    -1,    -1,    -1,    12,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     0,     1,    -1,    -1,    -1,    -1,     6,
       7,     8,    -1,    -1,    11,    12,    13,   315,    15,    -1,
      17,    18,    19,    20,    21,    22,    23,    -1,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    41,   343,   344,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,   648,
      -1,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    -1,
      -1,    -1,    79,    80,    -1,    82,    83,   114,   115,   116,
     117,   118,   119,   120,   121,   122,   123,    -1,    -1,    -1,
     398,    -1,   129,   130,    -1,    -1,   133,   104,    -1,   136,
     107,   138,   139,   140,    -1,   142,    -1,    -1,    -1,   116,
      -1,    -1,    -1,   120,    -1,    -1,   123,    -1,    -1,    -1,
      -1,    -1,   129,   130,   131,   433,   133,    -1,    -1,   136,
      -1,    -1,    -1,   140,    -1,   142,    -1,    -1,    -1,   146,
     147,   148,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   461,   462,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    12,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   483,    -1,    -1,     6,     7,
       8,   489,    -1,    11,    12,    13,    14,    15,    -1,    -1,
      18,    19,    20,    21,    22,    23,    -1,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
     518,    39,    -1,    -1,    -1,    -1,    -1,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    -1,    -1,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    -1,    -1,
      -1,    79,    80,    -1,    82,    83,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,   123,    -1,   104,    -1,    -1,   107,
     129,   130,    -1,    -1,   133,    -1,    -1,   136,   116,   138,
     139,   140,   120,   142,    -1,   123,    -1,    -1,    -1,    -1,
      12,   129,   130,   131,    -1,   133,    -1,    -1,   136,    -1,
      -1,    -1,   140,    -1,   142,     6,     7,     8,   146,   147,
      11,    12,    13,    -1,    15,    -1,    -1,    18,    19,    20,
      21,    22,    23,    -1,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    -1,    39,    -1,
      -1,    -1,    -1,    -1,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    -1,    -1,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    -1,    -1,    -1,    79,    80,
      -1,    82,    83,    -1,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,    -1,   104,    -1,    -1,   107,   129,   130,    -1,
      -1,   133,    -1,    -1,   136,   116,   138,   139,   140,   120,
     142,    -1,   123,    -1,    -1,    -1,    -1,    12,   129,   130,
     131,    -1,   133,    -1,    -1,   136,    -1,    -1,    -1,   140,
      -1,   142,     6,     7,     8,   146,   147,    11,    12,    13,
      14,    15,    -1,    -1,    18,    19,    20,    21,    22,    23,
      -1,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    -1,    39,    -1,    -1,    -1,    -1,
      -1,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    -1,    -1,    58,    59,    60,    61,    -1,    -1,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    -1,    -1,    -1,    79,    80,    -1,    82,    83,
      -1,    -1,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,    -1,
     104,    -1,    -1,   107,   129,   130,    -1,    -1,   133,    -1,
      -1,   136,   116,   138,   139,   140,   120,   142,    -1,   123,
      -1,    -1,    -1,    -1,    12,   129,   130,   131,    -1,   133,
      -1,    -1,   136,    -1,    -1,    -1,   140,    -1,   142,     6,
       7,     8,   146,   147,    11,    12,    13,    -1,    15,    -1,
      -1,    18,    19,    20,    21,    22,    23,    -1,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    -1,    39,    -1,    -1,    -1,    -1,    -1,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    -1,
      -1,    58,    59,    60,    61,    -1,    -1,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    -1,
      -1,    -1,    79,    80,    -1,    82,    83,    -1,    -1,    -1,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,    -1,   104,    -1,    -1,
     107,   129,   130,    -1,    -1,   133,    -1,    -1,   136,   116,
     138,   139,   140,   120,   142,    12,   123,    -1,    -1,    -1,
      -1,    -1,   129,   130,   131,    -1,   133,    -1,    -1,   136,
      -1,    -1,    -1,   140,    -1,   142,     6,     7,     8,   146,
     147,    11,    12,    13,    -1,    15,    -1,    -1,    18,    19,
      20,    21,    22,    23,    -1,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    -1,    39,
      -1,    -1,    -1,    -1,    -1,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    -1,    -1,    58,    59,
      60,    61,    -1,    -1,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    -1,    -1,    -1,    79,
      80,    -1,    82,    83,    -1,    -1,    -1,    -1,    -1,   116,
     117,   118,   119,   120,   121,   122,   123,    -1,    -1,    -1,
      -1,    -1,   129,   130,   104,    -1,   133,   107,    -1,   136,
      -1,   138,   139,   140,    -1,   142,   116,    -1,    -1,    -1,
     120,    -1,    -1,   123,    -1,    -1,    -1,    -1,    -1,   129,
     130,   131,    -1,   133,    -1,    -1,   136,    -1,    -1,    -1,
     140,    -1,   142,     6,     7,     8,   146,   147,    11,    12,
      -1,    -1,    15,    -1,    -1,    18,    19,    20,    21,    22,
      23,    -1,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    45,    46,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    55,    -1,    -1,    -1,    59,    60,    61,    -1,
      -1,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    -1,    -1,    -1,    79,    80,    -1,    82,
      83,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   104,    -1,    -1,   107,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   116,    -1,    -1,    -1,   120,    -1,    -1,
     123,    -1,    -1,    -1,    -1,    -1,   129,   130,   131,    -1,
     133,    -1,    -1,   136,     6,     7,     8,   140,    -1,   142,
      12,    13,    -1,    15,    -1,    -1,    18,    19,    20,    21,
      22,    23,    -1,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    45,    46,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    55,    -1,    -1,    -1,    59,    60,    61,
      -1,    -1,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    -1,    -1,    -1,    79,    80,    -1,
      82,    83,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   104,    -1,    -1,   107,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   116,    -1,    -1,    -1,   120,    -1,
      -1,   123,    -1,    -1,    -1,    -1,    -1,   129,   130,   131,
      -1,   133,    -1,    -1,   136,     6,     7,     8,   140,    -1,
     142,    12,    -1,    -1,    15,    -1,    -1,    18,    19,    20,
      21,    22,    23,    -1,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    -1,    37,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    45,    46,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,    59,    60,
      61,    -1,    -1,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    -1,    -1,    -1,    79,    80,
      -1,    82,    83,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   104,    -1,    -1,   107,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   116,    -1,    -1,    -1,   120,
      -1,    -1,   123,    -1,    -1,    -1,    -1,    -1,   129,   130,
     131,    -1,   133,    -1,    -1,   136,     6,     7,     8,   140,
      -1,   142,    12,    -1,    -1,    15,    -1,    -1,    18,    19,
      20,    21,    22,    23,    -1,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    45,    46,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,    59,
      60,    61,    -1,    -1,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    -1,    -1,    -1,    79,
      80,    -1,    82,    83,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   104,    -1,    -1,   107,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   116,    -1,    -1,    -1,
     120,    -1,    -1,   123,    -1,    -1,    -1,    -1,    -1,   129,
     130,   131,    -1,   133,    -1,   135,   136,     6,     7,     8,
     140,    -1,   142,    12,    -1,    -1,    15,    -1,    -1,    18,
      19,    20,    21,    22,    23,    -1,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    45,    46,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,
      59,    60,    61,    -1,    -1,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    -1,    -1,    -1,
      79,    80,    -1,    82,    83,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   104,    -1,    -1,   107,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   116,    -1,    -1,
      -1,   120,    -1,    -1,   123,    -1,    -1,    -1,    -1,    -1,
     129,   130,   131,    -1,   133,    -1,    -1,   136,     6,     7,
       8,   140,    -1,   142,    12,    13,    14,    15,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    -1,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    55,    -1,    -1,
      -1,    59,    60,    61,    -1,    -1,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    -1,    -1,
      -1,    79,    80,    81,    82,    83,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   104,    -1,    -1,   107,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   116,    -1,
      -1,    -1,   120,    -1,    -1,   123,    -1,    -1,    -1,    -1,
      -1,   129,   130,   131,    -1,   133,    -1,    -1,   136,     6,
       7,     8,   140,    -1,   142,    12,    -1,    -1,    15,    16,
      -1,    -1,    -1,    -1,    -1,    22,    23,    -1,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    55,    -1,
      -1,    -1,    59,    60,    61,    -1,    -1,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    -1,
      -1,    -1,    79,    80,    -1,    82,    83,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   104,    -1,    -1,
     107,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   116,
      -1,    -1,    -1,   120,    -1,    -1,   123,    -1,    -1,    -1,
      -1,    -1,   129,   130,   131,    -1,   133,    -1,    -1,   136,
       6,     7,     8,   140,   141,   142,    12,    13,    -1,    15,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    -1,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      -1,    37,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    55,
      -1,    -1,    -1,    59,    60,    61,    -1,    -1,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      -1,    -1,    -1,    79,    80,    -1,    82,    83,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   104,    -1,
      -1,   107,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     116,    -1,    -1,    -1,   120,    -1,    -1,   123,    -1,    -1,
      -1,    -1,    -1,   129,   130,   131,    -1,   133,    -1,    -1,
     136,     6,     7,     8,   140,    -1,   142,    12,    -1,    -1,
      15,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    -1,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    -1,    37,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      55,    -1,    -1,    -1,    59,    60,    61,    -1,    -1,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    -1,    -1,    -1,    79,    80,    81,    82,    83,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   104,
      -1,    -1,   107,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   116,    -1,    -1,    -1,   120,    -1,    -1,   123,    -1,
      -1,    -1,    -1,    -1,   129,   130,   131,    -1,   133,    -1,
      -1,   136,     6,     7,     8,   140,    -1,   142,    12,    -1,
      14,    15,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      -1,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    55,    -1,    -1,    -1,    59,    60,    61,    -1,    -1,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    -1,    -1,    -1,    79,    80,    81,    82,    83,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     104,    -1,    -1,   107,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   116,    -1,    -1,    -1,   120,    -1,    -1,   123,
      -1,    -1,    -1,    -1,    -1,   129,   130,   131,    -1,   133,
      -1,    -1,   136,     6,     7,     8,   140,    -1,   142,    12,
      13,    14,    15,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    -1,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    55,    -1,    -1,    -1,    59,    60,    61,    -1,
      -1,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    -1,    -1,    -1,    79,    80,    -1,    82,
      83,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   104,    -1,    -1,   107,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   116,    -1,    -1,    -1,   120,    -1,    -1,
     123,    -1,    -1,    -1,    -1,    -1,   129,   130,   131,    -1,
     133,    -1,    -1,   136,     6,     7,     8,   140,    -1,   142,
      12,    -1,    -1,    15,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    -1,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    -1,    37,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    55,    -1,    -1,    -1,    59,    60,    61,
      -1,    -1,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    -1,    -1,    -1,    79,    80,    -1,
      82,    83,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   104,    -1,    -1,   107,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   116,    -1,    -1,    -1,   120,    -1,
      -1,   123,    -1,    -1,    -1,    -1,    -1,   129,   130,   131,
      -1,   133,    -1,    -1,   136,     6,     7,     8,   140,    -1,
     142,    12,    -1,    -1,    15,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    -1,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,    59,    60,
      61,    -1,    -1,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    -1,    -1,    -1,    79,    80,
      -1,    82,    83,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   104,    -1,    -1,   107,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   116,    -1,    -1,    -1,   120,
      -1,    -1,   123,    -1,    -1,    -1,    -1,    -1,   129,   130,
     131,    -1,   133,    -1,    -1,   136,     6,     7,     8,   140,
     141,   142,    12,    -1,    -1,    15,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    -1,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,    59,
      60,    61,    -1,    -1,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    -1,    -1,    -1,    79,
      80,    -1,    82,    83,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   104,    -1,    -1,   107,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   116,    -1,    -1,    -1,
     120,    -1,    -1,   123,    -1,    -1,    -1,    -1,    -1,   129,
     130,   131,    -1,   133,    -1,   135,   136,     6,     7,     8,
     140,    -1,   142,    12,    -1,    -1,    15,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    -1,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,
      59,    60,    61,    -1,    -1,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    -1,    -1,    -1,
      79,    80,    -1,    82,    83,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   104,    -1,    -1,   107,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   116,    -1,    -1,
      -1,   120,    -1,    -1,   123,    -1,    -1,    -1,    -1,    -1,
     129,   130,   131,    -1,   133,    -1,   135,   136,     6,     7,
       8,   140,    -1,   142,    12,    13,    -1,    15,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    -1,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    55,    -1,    -1,
      -1,    59,    60,    61,    -1,    -1,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    -1,    -1,
      -1,    79,    80,    -1,    82,    83,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   104,    -1,    -1,   107,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   116,    -1,
      -1,    -1,   120,    -1,    -1,   123,    -1,    -1,    -1,    -1,
      -1,   129,   130,   131,    -1,   133,    -1,    -1,   136,     6,
       7,     8,   140,    -1,   142,    12,    13,    -1,    15,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    23,    -1,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    55,    -1,
      -1,    -1,    59,    60,    61,    -1,    -1,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    -1,
      -1,    -1,    79,    80,    -1,    82,    83,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   104,    -1,    -1,
     107,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   116,
      -1,    -1,    -1,   120,    -1,    -1,   123,    -1,    -1,    -1,
      -1,    -1,   129,   130,   131,    -1,   133,    -1,    -1,   136,
       6,     7,     8,   140,    -1,   142,    12,    -1,    -1,    15,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    -1,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    55,
      -1,    -1,    -1,    59,    60,    61,    -1,    -1,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      11,    12,    -1,    79,    80,    -1,    82,    83,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   104,    -1,
      -1,   107,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     116,    -1,    -1,    -1,   120,    -1,    -1,   123,    -1,    -1,
      -1,    -1,    -1,   129,   130,   131,    -1,   133,    -1,    12,
     136,    -1,    -1,    16,   140,    -1,   142,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
      -1,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   123,    -1,    -1,    -1,    -1,    12,   129,   130,
      -1,    -1,   133,    -1,    -1,   136,    -1,   138,   139,   140,
      -1,   142,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,    -1,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
     123,    -1,    -1,    -1,    -1,    12,   129,   130,    -1,    -1,
     133,    -1,    -1,   136,    -1,   138,   139,   140,    -1,   142,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,    -1,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,    -1,
      -1,    -1,    -1,    12,   129,   130,    -1,    -1,   133,    -1,
      -1,   136,    -1,   138,   139,   140,    -1,   142,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,    -1,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,   123,    -1,    -1,    -1,
      -1,    12,   129,   130,    -1,    -1,   133,    -1,    -1,   136,
      -1,   138,   139,   140,    -1,   142,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,    -1,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,   123,    -1,    -1,    -1,    12,    -1,
     129,   130,    -1,    -1,   133,    -1,    -1,   136,    -1,   138,
     139,   140,    -1,   142,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
      -1,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   123,    -1,    -1,    -1,    -1,    -1,   129,   130,
      12,    -1,   133,    -1,    -1,   136,    -1,   138,   139,   140,
      -1,   142,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
      -1,    -1,    -1,    -1,    -1,   129,   130,    12,    -1,   133,
      -1,    -1,   136,    -1,   138,   139,   140,    -1,   142,    81,
      -1,    -1,    -1,    -1,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,    -1,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,    12,    -1,    -1,    -1,    -1,   129,   130,    -1,
      -1,   133,    -1,    -1,   136,    -1,   138,   139,   140,    -1,
     142,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,    -1,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,    12,
      -1,    -1,    -1,    -1,   129,   130,    -1,    -1,   133,    -1,
      -1,   136,    -1,   138,   139,   140,    -1,   142,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,    -1,    -1,    -1,    -1,    -1,   129,
     130,    -1,    -1,   133,    -1,    -1,   136,    -1,   138,   139,
     140,    -1,   142,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
     123,    -1,    -1,    -1,    -1,    -1,   129,   130,    -1,    -1,
     133,    -1,    -1,   136,    -1,   138,   139,   140,    -1,   142,
       6,     7,     8,    -1,    -1,    -1,    -1,    -1,    14,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    -1,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       6,     7,     8,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    60,    61,    22,    23,    -1,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    60,    61,    -1,    -1,   104,    -1,
      -1,   107,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   120,    -1,    -1,   123,    -1,    -1,
      -1,    -1,    -1,     6,     7,     8,    -1,    -1,    -1,    -1,
     136,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   104,    22,
      23,   107,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    -1,   120,    -1,    -1,   123,    -1,    -1,
      -1,    -1,    -1,     6,     7,     8,    -1,    -1,    -1,   135,
     136,    -1,    -1,    -1,    -1,    -1,    -1,    60,    61,    22,
      23,    -1,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    59,    60,    61,    -1,
      -1,   104,    -1,    -1,   107,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   120,    -1,    -1,
     123,    -1,    -1,    -1,    -1,    -1,     6,     7,     8,    -1,
      -1,    -1,   135,   136,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   104,    22,    23,   107,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    -1,   120,    -1,    -1,
     123,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   136,    -1,    -1,    -1,    -1,    -1,    -1,
      60,    61,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   104,    -1,    -1,   107,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     120,    -1,    -1,   123,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   136
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,   152,     0,     1,    17,   148,   153,   158,   162,   157,
       6,     7,     8,    11,    12,    13,    15,    18,    19,    20,
      21,    22,    23,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    39,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    79,    80,    82,    83,   104,
     107,   116,   120,   123,   129,   130,   131,   133,   136,   140,
     142,   146,   147,   168,   169,   171,   172,   175,   176,   179,
     180,   181,   185,   192,   209,   210,   212,   214,   215,   216,
     217,   225,   226,   227,   228,   238,   239,   246,    11,    17,
     148,   154,    13,    13,    13,    64,    65,    66,    67,    68,
     249,   173,   247,   249,   155,   169,   171,   155,   155,   155,
     155,    11,    11,     7,     8,   212,   227,   237,   238,   214,
     246,   155,   144,   240,   241,   246,   163,   164,   165,   167,
     136,   136,   214,   246,   214,   246,   246,   214,   246,   214,
     246,   246,   246,   246,   246,   142,   175,   214,   238,   141,
     155,   155,    60,    61,   172,   178,   180,   238,   174,   157,
     156,    51,   193,   194,   173,    36,    59,   206,   207,   117,
     140,   148,   159,   136,   142,   213,   229,    37,    61,   104,
     107,   120,   123,   136,   171,   214,   216,    38,    40,    41,
     224,   225,    44,    11,    84,   157,    85,    12,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,   123,   129,   130,   133,   136,   138,
     139,   140,   142,   248,   216,   222,   216,   223,    59,   203,
      59,   136,   173,   173,   173,   173,    59,    11,   173,   157,
      85,   157,    85,    59,    60,    61,   166,   246,   246,   120,
     214,   219,   221,   246,   135,   135,   140,   135,    13,   181,
     184,   173,   144,   174,   177,   178,   156,   159,   155,    78,
     195,    11,   188,   189,   190,   155,   233,    59,   136,   100,
     211,   214,    59,   135,   214,   230,   231,    16,   214,   218,
     219,   220,   221,   213,   173,   214,   214,   214,   214,   214,
      61,   159,   155,   155,   155,   216,   155,   238,   148,   246,
     246,   246,   246,   246,   246,   246,   246,   246,   246,   246,
     246,   246,   246,   246,   246,   246,   246,   246,   246,   246,
     246,   242,   243,   246,   221,    59,    59,   221,   246,   203,
      14,   203,    14,    85,    14,   136,   240,   136,   180,   136,
     136,   136,    11,   160,   241,   160,   164,   144,    85,    85,
     141,    85,   141,   141,    85,   173,    59,   178,   186,   136,
      14,   173,   174,   156,   175,   191,   214,   216,   234,   235,
     135,   136,    13,   246,   251,   259,   263,   266,    85,   208,
      59,   135,    16,    85,   236,   141,   141,    85,   141,   141,
     136,   232,   135,    59,    59,    60,   204,   205,   214,   169,
     170,   159,    61,   172,   157,   101,   135,    85,   236,   141,
     141,    11,    11,   203,   135,   238,    48,   183,   237,   238,
     237,   148,   148,   214,    59,   135,   120,   135,   135,   221,
     266,   135,    14,   149,   187,   238,   136,   100,    59,    85,
     236,    14,    59,    81,   140,   142,   246,   256,   257,   260,
     261,   264,   265,   266,   206,   230,   213,   213,    16,   213,
     213,   233,   194,   173,    11,    85,    60,   204,    85,    11,
     182,   148,   246,   243,   222,   223,    11,   135,   136,   135,
      11,   135,    11,   135,   135,   173,   173,   173,   174,   246,
     169,   135,   238,   246,   234,   100,   246,   262,   266,    59,
     173,    81,    85,   161,    85,   161,    85,   161,   135,   156,
     244,   245,   229,   156,   204,    11,   170,   156,    13,   180,
     238,   180,   183,   176,   196,   237,    13,   258,   259,    13,
     251,    13,   250,   251,   173,   180,   135,    11,   246,   266,
     100,    59,   253,   254,   262,   246,   257,   236,   246,   261,
      14,    59,   140,   265,    14,   100,   174,   175,   174,   156,
     178,   174,   135,   174,    56,    57,   197,   198,   174,   135,
      14,   174,   174,    14,   174,   232,   150,   176,   199,   246,
     266,   255,    85,    14,   246,   194,    14,   156,   174,   156,
     238,   101,   177,   197,   156,   180,   194,   180,    56,    57,
     200,   201,   174,   141,   253,    11,   156,   156,   101,   178,
     174,   175,   173,   101,   177,   200,   156,   100,   175,   252,
     156,   178,   156,   174,    59,   178,   257,   174,    59,   202,
      14,   101,   178,   174
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* This macro is provided for backward compatibility. */

#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (0, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  YYSIZE_T yysize1;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = 0;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - Assume YYFAIL is not used.  It's too flawed to consider.  See
       <http://lists.gnu.org/archive/html/bison-patches/2009-12/msg00024.html>
       for details.  YYERROR is fine as it does not invoke this
       function.
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                yysize1 = yysize + yytnamerr (0, yytname[yyx]);
                if (! (yysize <= yysize1
                       && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                  return 2;
                yysize = yysize1;
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  yysize1 = yysize + yystrlen (yyformat);
  if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
    return 2;
  yysize = yysize1;

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */


/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 6:

/* Line 1806 of yacc.c  */
#line 198 "gram.y"
    { yyerrok; }
    break;

  case 7:

/* Line 1806 of yacc.c  */
#line 200 "gram.y"
    { yyerrok; }
    break;

  case 8:

/* Line 1806 of yacc.c  */
#line 202 "gram.y"
    { yyerrok; }
    break;

  case 9:

/* Line 1806 of yacc.c  */
#line 210 "gram.y"
    { ignorenl++; }
    break;

  case 10:

/* Line 1806 of yacc.c  */
#line 213 "gram.y"
    { if (ignorenl > 0) ignorenl--; }
    break;

  case 11:

/* Line 1806 of yacc.c  */
#line 216 "gram.y"
    { 
			ignorenl = 0; 
			LexNamespace = 0; 
			CurrentNamespace = TopNamespace; 
			funcDepth = 0; 
			notCommand = 0;
			lastThreadError = True;
		    }
    break;

  case 12:

/* Line 1806 of yacc.c  */
#line 234 "gram.y"
    { notCommand = 1; }
    break;

  case 19:

/* Line 1806 of yacc.c  */
#line 249 "gram.y"
    {
			ENTER ();
			ExprPtr	e;
			Value	t;
			NamespacePtr	s;
			FramePtr	f;
			CodePtr		c;
			
			e = BuildCall ("Command", "display",
				       1,NewExprTree (EXPR, (yyvsp[(2) - (4)].expr), 0));
			GetNamespace (&s, &f, &c);
			t = NewThread (f, CompileExpr (e, c));
			ThreadsRun (t, 0);
			EXIT ();
		    }
    break;

  case 20:

/* Line 1806 of yacc.c  */
#line 265 "gram.y"
    {
			ENTER ();
			ExprPtr	e;
			Value	t;
			NamespacePtr	s;
			FramePtr	f;
			CodePtr		c;

			e = BuildCall("Command", "display_base",
				      2, NewExprTree (EXPR, (yyvsp[(2) - (6)].expr), 0), (yyvsp[(4) - (6)].expr));
			GetNamespace (&s, &f, &c);
			t = NewThread (f, CompileExpr (e, c));
			ThreadsRun (t, 0);
			EXIT ();
		    }
    break;

  case 21:

/* Line 1806 of yacc.c  */
#line 281 "gram.y"
    { 
			ENTER ();
			NamespacePtr    s;
			FramePtr	f;
			CodePtr		c;
			Value		t;
			
			GetNamespace (&s, &f, &c);
			t = NewThread (f, CompileStat ((yyvsp[(2) - (4)].expr), c));
			ThreadsRun (t, 0);
			EXIT ();
		    }
    break;

  case 22:

/* Line 1806 of yacc.c  */
#line 294 "gram.y"
    {
			ENTER();
			ExprPtr	e;
			Value	t;
			NamespacePtr	s;
			FramePtr	f;
			CodePtr		c;
			CommandPtr	cmd;

			cmd = CommandFind (CurrentCommands, (yyvsp[(2) - (6)].atom));
			if (!cmd)
			    ParseError ("Undefined command \"%s\"", AtomName ((yyvsp[(2) - (6)].atom)));
			else
			{
			    e = NewExprTree (OP, 
					     NewExprConst (POLY_CONST, cmd->func),
					     (yyvsp[(3) - (6)].expr));
			    GetNamespace (&s, &f, &c);
			    t = NewThread (f, CompileExpr (e, c));
			    ThreadsRun (t, 0);
			}
			EXIT ();
		    }
    break;

  case 23:

/* Line 1806 of yacc.c  */
#line 318 "gram.y"
    {
			ENTER ();
			ExprPtr e;

			Value	t;
			NamespacePtr	s;
			FramePtr	f;
			CodePtr		c;
			CommandPtr	cmd;

			cmd = CommandFind (CurrentCommands, (yyvsp[(2) - (6)].atom));
			if (!cmd)
			    ParseError ("Undefined command \"%s\"", AtomName ((yyvsp[(2) - (6)].atom)));
			else
			{
			    e = NewExprTree (OP, 
					     NewExprConst (POLY_CONST, cmd->func),
					     (yyvsp[(3) - (6)].expr));
			    GetNamespace (&s, &f, &c);
			    t = NewThread (f, CompileExpr (e, c));
			    ThreadsRun (t, 0);
			}
			EXIT ();
		    }
    break;

  case 27:

/* Line 1806 of yacc.c  */
#line 347 "gram.y"
    { (yyval.expr) = 0; }
    break;

  case 28:

/* Line 1806 of yacc.c  */
#line 350 "gram.y"
    { (yyval.expr) = NewExprTree (COMMA, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr)); }
    break;

  case 29:

/* Line 1806 of yacc.c  */
#line 352 "gram.y"
    { (yyval.expr) = NewExprTree (COMMA, (yyvsp[(1) - (1)].expr), 0); }
    break;

  case 30:

/* Line 1806 of yacc.c  */
#line 355 "gram.y"
    { (yyval.expr) = BuildRawname ((yyvsp[(1) - (2)].expr), (yyvsp[(2) - (2)].atom)); }
    break;

  case 34:

/* Line 1806 of yacc.c  */
#line 362 "gram.y"
    { (yyval.expr) = NewExprTree (COLONCOLON, (yyvsp[(1) - (3)].expr), NewExprAtom ((yyvsp[(2) - (3)].atom), 0, False)); }
    break;

  case 35:

/* Line 1806 of yacc.c  */
#line 364 "gram.y"
    { (yyval.expr) = 0; }
    break;

  case 36:

/* Line 1806 of yacc.c  */
#line 367 "gram.y"
    { 
			(yyval.expr) = BuildFullname ((yyvsp[(1) - (2)].expr), (yyvsp[(2) - (2)].atom));
			LexNamespace = 0;
		    }
    break;

  case 37:

/* Line 1806 of yacc.c  */
#line 372 "gram.y"
    { 
			(yyval.expr) = BuildFullname (0, (yyvsp[(1) - (1)].atom));
			LexNamespace = 0;
		    }
    break;

  case 38:

/* Line 1806 of yacc.c  */
#line 378 "gram.y"
    { 
			(yyval.expr) = BuildFullname ((yyvsp[(1) - (2)].expr), (yyvsp[(2) - (2)].atom));
			LexNamespace = 0;
		    }
    break;

  case 39:

/* Line 1806 of yacc.c  */
#line 383 "gram.y"
    {
			(yyval.expr) = BuildFullname (0, (yyvsp[(1) - (1)].atom));
			LexNamespace = 0;
		    }
    break;

  case 40:

/* Line 1806 of yacc.c  */
#line 389 "gram.y"
    {
			(yyval.expr) = (yyvsp[(1) - (1)].expr);
		    }
    break;

  case 41:

/* Line 1806 of yacc.c  */
#line 393 "gram.y"
    {
			(yyval.expr) = NewExprTree (COMMA, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
		    }
    break;

  case 42:

/* Line 1806 of yacc.c  */
#line 398 "gram.y"
    { 
			ExprPtr	    e;
			SymbolPtr   symbol;

			e = BuildFullname ((yyvsp[(1) - (3)].expr), (yyvsp[(2) - (3)].atom));
			if (e->base.tag == COLONCOLON)
			    symbol = e->tree.right->atom.symbol;
			else
			    symbol = e->atom.symbol;
			if (!symbol)
			{
			    ParseError ("non-existant namespace \"%A\"", (yyvsp[(2) - (3)].atom));
			    YYERROR;
			}
			else if (symbol->symbol.class != class_namespace)
			{
			    ParseError ("%A is not a namespace", (yyvsp[(2) - (3)].atom));
			    YYERROR;
			}
			LexNamespace = symbol->namespace.namespace;
			(yyval.expr) = e;
		    }
    break;

  case 43:

/* Line 1806 of yacc.c  */
#line 421 "gram.y"
    { 
			ExprPtr	    e;
			SymbolPtr   symbol;

			e = BuildFullname (0, (yyvsp[(1) - (2)].atom));
			if (e->base.tag == COLONCOLON)
			    symbol = e->tree.right->atom.symbol;
			else
			    symbol = e->atom.symbol;
			if (!symbol)
			{
			    ParseError ("non-existant namespace \"%A\"", (yyvsp[(1) - (2)].atom));
			    YYERROR;
			}
			else if (symbol->symbol.class != class_namespace)
			{
			    ParseError ("%A is not a namespace", (yyvsp[(1) - (2)].atom));
			    YYERROR;
			}
			LexNamespace = symbol->namespace.namespace;
			(yyval.expr) = e;
		    }
    break;

  case 46:

/* Line 1806 of yacc.c  */
#line 451 "gram.y"
    { CurrentNamespace = NewNamespace (CurrentNamespace); }
    break;

  case 47:

/* Line 1806 of yacc.c  */
#line 454 "gram.y"
    { CurrentNamespace = CurrentNamespace->previous; }
    break;

  case 48:

/* Line 1806 of yacc.c  */
#line 457 "gram.y"
    { (yyval.expr) = (yyvsp[(2) - (3)].expr); }
    break;

  case 51:

/* Line 1806 of yacc.c  */
#line 464 "gram.y"
    { (yyval.expr) = NewExprTree(OC, (yyvsp[(1) - (2)].expr), (yyvsp[(2) - (2)].expr)); }
    break;

  case 52:

/* Line 1806 of yacc.c  */
#line 466 "gram.y"
    { (yyval.expr) = NewExprTree(OC, 0, 0); }
    break;

  case 53:

/* Line 1806 of yacc.c  */
#line 469 "gram.y"
    { (yyval.expr) = NewExprTree(IF, (yyvsp[(5) - (7)].expr), (yyvsp[(7) - (7)].expr)); }
    break;

  case 54:

/* Line 1806 of yacc.c  */
#line 471 "gram.y"
    { (yyval.expr) = NewExprTree(ELSE, (yyvsp[(5) - (9)].expr), NewExprTree(ELSE, (yyvsp[(7) - (9)].expr), (yyvsp[(9) - (9)].expr))); }
    break;

  case 57:

/* Line 1806 of yacc.c  */
#line 478 "gram.y"
    { (yyval.expr) = (yyvsp[(1) - (3)].expr); }
    break;

  case 58:

/* Line 1806 of yacc.c  */
#line 480 "gram.y"
    { (yyval.expr) = NewExprTree(WHILE, (yyvsp[(5) - (9)].expr), (yyvsp[(7) - (9)].expr)); }
    break;

  case 59:

/* Line 1806 of yacc.c  */
#line 482 "gram.y"
    { (yyval.expr) = NewExprTree(DO, (yyvsp[(4) - (10)].expr), (yyvsp[(7) - (10)].expr)); }
    break;

  case 60:

/* Line 1806 of yacc.c  */
#line 484 "gram.y"
    { Expr *expr = ParseCanonFor((yyvsp[(5) - (9)].expr));
		      if (!expr)
                          YYERROR;
		      (yyval.expr) = NewExprTree(FOR, expr, (yyvsp[(7) - (9)].expr)); }
    break;

  case 61:

/* Line 1806 of yacc.c  */
#line 489 "gram.y"
    { (yyval.expr) = NewExprTree (SWITCH, (yyvsp[(5) - (9)].expr), (yyvsp[(7) - (9)].expr)); }
    break;

  case 62:

/* Line 1806 of yacc.c  */
#line 491 "gram.y"
    { (yyval.expr) = NewExprTree (UNION, (yyvsp[(6) - (10)].expr), (yyvsp[(8) - (10)].expr)); }
    break;

  case 63:

/* Line 1806 of yacc.c  */
#line 493 "gram.y"
    { (yyval.expr) = NewExprTree(BREAK, (Expr *) 0, (Expr *) 0); }
    break;

  case 64:

/* Line 1806 of yacc.c  */
#line 495 "gram.y"
    { (yyval.expr) = NewExprTree(CONTINUE, (Expr *) 0, (Expr *) 0); }
    break;

  case 65:

/* Line 1806 of yacc.c  */
#line 497 "gram.y"
    { (yyval.expr) = NewExprTree (RETURNTOK, (Expr *) 0, (yyvsp[(2) - (3)].expr)); }
    break;

  case 66:

/* Line 1806 of yacc.c  */
#line 499 "gram.y"
    { (yyval.expr) = NewExprTree(EXPR, (yyvsp[(1) - (2)].expr), (Expr *) 0); }
    break;

  case 67:

/* Line 1806 of yacc.c  */
#line 501 "gram.y"
    { (yyval.expr) = NewExprTree(SEMI, (Expr *) 0, (Expr *) 0); }
    break;

  case 68:

/* Line 1806 of yacc.c  */
#line 503 "gram.y"
    { 
			DeclList    *decl = (yyvsp[(1) - (4)].funcDecl).decl;
			SymbolPtr   symbol = decl->symbol;
			Class	    class = (yyvsp[(1) - (4)].funcDecl).type.class;
			Publish	    publish = (yyvsp[(1) - (4)].funcDecl).type.publish;
			TypePtr	    type = (yyvsp[(1) - (4)].funcDecl).type.type;
			TypePtr	    ret = type->func.ret;
			ArgType	    *argType = type->func.args;

			if (symbol)
			{
			    if ((yyvsp[(3) - (4)].expr))
			    {
				symbol->symbol.forward = False;
				ParseCanonType (ret, False);
				decl->init = NewExprCode (NewFuncCode (ret,
								       argType,
								       (yyvsp[(3) - (4)].expr),
								       (yyvsp[(2) - (4)].value)),
							  NewExprAtom (symbol->symbol.name, symbol, False));
			    }
			    else
				symbol->symbol.forward = True;
			}
			(yyval.expr) = NewExprDecl (FUNC, decl, class, type, publish);
		    }
    break;

  case 69:

/* Line 1806 of yacc.c  */
#line 530 "gram.y"
    { 
			DeclListPtr decl;

			decl = NewDeclList ((yyvsp[(4) - (10)].atom), 0, 0);
			decl->symbol = ParseNewSymbol ((yyvsp[(1) - (10)].publish), 
						       class_exception, 
						       typePoly, (yyvsp[(4) - (10)].atom));
			decl->symbol->exception.doc = (yyvsp[(8) - (10)].value);
			(yyval.expr) = NewExprDecl (EXCEPTION,
					  decl,
					  class_exception,
					  NewTypeFunc (typePoly, (yyvsp[(6) - (10)].argType)),
					  (yyvsp[(1) - (10)].publish));
		    }
    break;

  case 70:

/* Line 1806 of yacc.c  */
#line 545 "gram.y"
    { (yyval.expr) = NewExprTree (RAISE, (yyvsp[(2) - (6)].expr), (yyvsp[(4) - (6)].expr)); }
    break;

  case 71:

/* Line 1806 of yacc.c  */
#line 547 "gram.y"
    { 
			DeclListPtr decl;

			for (decl = (yyvsp[(4) - (6)].declList); decl; decl = decl->next)
			    decl->symbol = ParseNewSymbol ((yyvsp[(1) - (6)].publish), class_typedef,
							   0, decl->name);
			(yyval.expr) = NewExprTree (TYPEDEF, NewExprDecl (TYPEDEF, (yyvsp[(4) - (6)].declList), class_typedef, 0, (yyvsp[(1) - (6)].publish)), 0);
		    }
    break;

  case 72:

/* Line 1806 of yacc.c  */
#line 556 "gram.y"
    { 
			DeclListPtr decl;

			for (decl = (yyvsp[(5) - (7)].declList); decl; decl = decl->next)
			    decl->symbol = ParseNewSymbol ((yyvsp[(1) - (7)].publish), class_typedef,
							   (yyvsp[(4) - (7)].type), decl->name);
			(yyval.expr) = NewExprTree (TYPEDEF, NewExprDecl (TYPEDEF, (yyvsp[(5) - (7)].declList), class_typedef, (yyvsp[(4) - (7)].type), (yyvsp[(1) - (7)].publish)), 0);
		    }
    break;

  case 73:

/* Line 1806 of yacc.c  */
#line 565 "gram.y"
    {
			SymbolPtr   symbol;
			Publish	    publish = (yyvsp[(1) - (4)].publish);
			
			/*
			 * this is a hack - save the current namespace
			 * on the parser stack to be restored after
			 * the block is compiled.
			 */
			(yyvsp[(2) - (4)].namespace) = CurrentNamespace;
			if (publish == publish_extend)
			{
			    symbol = NamespaceFindName (CurrentNamespace, (yyvsp[(4) - (4)].atom), True);
			    if (!symbol)
			    {
				ParseError ("non-existant namespace %A", (yyvsp[(4) - (4)].atom));
				YYERROR;
			    }
			    else if (symbol->symbol.class != class_namespace)
			    {
				ParseError ("%A is not a namespace", (yyvsp[(4) - (4)].atom));
				YYERROR;
			    }
			    else
				CurrentNamespace = symbol->namespace.namespace;
			}
			else
			{
			    symbol = ParseNewSymbol ((yyvsp[(1) - (4)].publish), class_namespace,
						     0, (yyvsp[(4) - (4)].atom));
			    CurrentNamespace = NewNamespace (CurrentNamespace);
			    symbol->namespace.namespace = CurrentNamespace;
			}
			/*
			 * Make all of the symbols visible while compiling within
			 * the namespace
			 */
			if (CurrentNamespace != (yyvsp[(2) - (4)].namespace))
			    CurrentNamespace->publish = publish_public;
		    }
    break;

  case 74:

/* Line 1806 of yacc.c  */
#line 606 "gram.y"
    {
			/*
			 * close the namespace to non-public lookups
			 */
			if (CurrentNamespace != (yyvsp[(2) - (9)].namespace))
			    CurrentNamespace->publish = publish_private;
			/*
			 * Restore to the namespace saved on
			 * the parser stack
			 */
			CurrentNamespace = (yyvsp[(2) - (9)].namespace);
			(yyval.expr) = NewExprTree (NAMESPACE, NewExprAtom ((yyvsp[(4) - (9)].atom), 0, False), (yyvsp[(7) - (9)].expr));
		    }
    break;

  case 75:

/* Line 1806 of yacc.c  */
#line 620 "gram.y"
    {
			SymbolPtr	symbol;
			ExprPtr		p, e, n;

			p = (yyvsp[(4) - (6)].expr);
			for (p = (yyvsp[(4) - (6)].expr); p; p = n)
			{
			    if (p->base.tag == COMMA)
			    {
				e = p->tree.left;
				n = p->tree.right;
			    }
			    else
			    {
				e = p;
				n = 0;
			    }
			    if (e->base.tag == COLONCOLON)
				e = e->tree.right;
			    symbol = e->atom.symbol;
			    if (!symbol)
			    {
				ParseError ("non-existant namespace %A", e->atom.atom);
				YYERROR;
			    }
			    else if (symbol->symbol.class != class_namespace)
			    {
				ParseError ("%A is not a namespace", e->atom.atom);
				YYERROR;
			    }
			    NamespaceImport (CurrentNamespace, 
					     symbol->namespace.namespace, (yyvsp[(1) - (6)].publish));
			}
			(yyval.expr) = NewExprTree (IMPORT, (yyvsp[(4) - (6)].expr), NewExprDecl (IMPORT,
								   0, 
								   class_undef,
								   0,
								   (yyvsp[(1) - (6)].publish)));
		    }
    break;

  case 76:

/* Line 1806 of yacc.c  */
#line 660 "gram.y"
    { (yyval.expr) = (yyvsp[(1) - (2)].expr); }
    break;

  case 77:

/* Line 1806 of yacc.c  */
#line 662 "gram.y"
    { (yyval.expr) = NewExprTree (TWIXT, 
					NewExprTree (TWIXT, (yyvsp[(5) - (11)].expr), (yyvsp[(7) - (11)].expr)),
					NewExprTree (TWIXT, (yyvsp[(9) - (11)].expr), 0));
		    }
    break;

  case 78:

/* Line 1806 of yacc.c  */
#line 668 "gram.y"
    { (yyval.expr) = NewExprTree(SEMI, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr)); }
    break;

  case 79:

/* Line 1806 of yacc.c  */
#line 670 "gram.y"
    { (yyval.expr) = NewExprTree(SEMI, (yyvsp[(1) - (1)].expr), 0); }
    break;

  case 81:

/* Line 1806 of yacc.c  */
#line 675 "gram.y"
    { (yyval.expr) = (yyvsp[(2) - (3)].expr); }
    break;

  case 82:

/* Line 1806 of yacc.c  */
#line 678 "gram.y"
    { (yyval.expr) = NewExprTree (CATCH, (yyvsp[(4) - (4)].expr), (yyvsp[(3) - (4)].expr)); }
    break;

  case 83:

/* Line 1806 of yacc.c  */
#line 682 "gram.y"
    { (yyval.expr) = NewExprTree (CATCH, (yyvsp[(1) - (2)].expr), (yyvsp[(2) - (2)].expr)); }
    break;

  case 84:

/* Line 1806 of yacc.c  */
#line 684 "gram.y"
    { (yyval.expr) = 0; }
    break;

  case 85:

/* Line 1806 of yacc.c  */
#line 687 "gram.y"
    { (yyval.expr) = NewExprCode (NewFuncCode (typePrim[rep_void],
						     (yyvsp[(4) - (7)].argType), (yyvsp[(6) - (7)].expr), (yyvsp[(5) - (7)].value)),
					(yyvsp[(2) - (7)].expr)); 
		    }
    break;

  case 87:

/* Line 1806 of yacc.c  */
#line 694 "gram.y"
    { (yyval.expr) = 0; }
    break;

  case 88:

/* Line 1806 of yacc.c  */
#line 696 "gram.y"
    { ++funcDepth; }
    break;

  case 89:

/* Line 1806 of yacc.c  */
#line 696 "gram.y"
    { --funcDepth; (yyval.expr) = (yyvsp[(2) - (2)].expr); }
    break;

  case 90:

/* Line 1806 of yacc.c  */
#line 699 "gram.y"
    { (yyval.expr) = (yyvsp[(1) - (1)].expr); }
    break;

  case 91:

/* Line 1806 of yacc.c  */
#line 701 "gram.y"
    { 
			(yyval.expr) = NewExprTree (OC,
					  NewExprTree (RETURNTOK, 0, (yyvsp[(3) - (4)].expr)),
					  NewExprTree (OC, 0, 0));
		    }
    break;

  case 94:

/* Line 1806 of yacc.c  */
#line 711 "gram.y"
    { seeComment = 1; }
    break;

  case 95:

/* Line 1806 of yacc.c  */
#line 714 "gram.y"
    { seeComment = 0; (yyval.value) = (yyvsp[(2) - (2)].value); }
    break;

  case 97:

/* Line 1806 of yacc.c  */
#line 718 "gram.y"
    { (yyval.value) = Void; }
    break;

  case 98:

/* Line 1806 of yacc.c  */
#line 721 "gram.y"
    { (yyval.expr) = (yyvsp[(2) - (3)].expr); }
    break;

  case 99:

/* Line 1806 of yacc.c  */
#line 724 "gram.y"
    { (yyval.expr) = NewExprTree (CASE, (yyvsp[(1) - (2)].expr), (yyvsp[(2) - (2)].expr)); }
    break;

  case 100:

/* Line 1806 of yacc.c  */
#line 726 "gram.y"
    { (yyval.expr) = 0; }
    break;

  case 101:

/* Line 1806 of yacc.c  */
#line 729 "gram.y"
    { (yyval.expr) = NewExprTree (CASE, (yyvsp[(2) - (4)].expr), (yyvsp[(4) - (4)].expr)); }
    break;

  case 102:

/* Line 1806 of yacc.c  */
#line 731 "gram.y"
    { (yyval.expr) = NewExprTree (CASE, 0, (yyvsp[(3) - (3)].expr)); }
    break;

  case 103:

/* Line 1806 of yacc.c  */
#line 734 "gram.y"
    { (yyval.expr) = (yyvsp[(2) - (3)].expr); }
    break;

  case 104:

/* Line 1806 of yacc.c  */
#line 737 "gram.y"
    { (yyval.expr) = NewExprTree (CASE, (yyvsp[(1) - (2)].expr), (yyvsp[(2) - (2)].expr)); }
    break;

  case 105:

/* Line 1806 of yacc.c  */
#line 739 "gram.y"
    { (yyval.expr) = 0; }
    break;

  case 106:

/* Line 1806 of yacc.c  */
#line 742 "gram.y"
    { 
			SymbolPtr   sym = (yyvsp[(4) - (7)].symbol);
			Atom	    sym_atom = sym ? sym->symbol.name : 0;
			ExprPtr	    name = 0;
			
			if (sym)
			    name = NewExprAtom (sym_atom, sym, False);
			    
			(yyval.expr) = NewExprTree (CASE, 
					  NewExprTree (CASE,
						       NewExprAtom ((yyvsp[(3) - (7)].atom), 0, False),
						       name),
					  (yyvsp[(6) - (7)].expr));
		    }
    break;

  case 107:

/* Line 1806 of yacc.c  */
#line 757 "gram.y"
    { (yyval.expr) = NewExprTree (CASE, 0, (yyvsp[(3) - (3)].expr)); }
    break;

  case 108:

/* Line 1806 of yacc.c  */
#line 760 "gram.y"
    {
			(yyval.symbol) = ParseNewSymbol (publish_private,
					     class_undef,
					     typePoly,
					     (yyvsp[(1) - (1)].atom));
		    }
    break;

  case 109:

/* Line 1806 of yacc.c  */
#line 767 "gram.y"
    { (yyval.symbol) = 0; }
    break;

  case 110:

/* Line 1806 of yacc.c  */
#line 773 "gram.y"
    { (yyval.atomList) = NewAtomList ((yyvsp[(3) - (3)].atomList), (yyvsp[(1) - (3)].atom)); }
    break;

  case 111:

/* Line 1806 of yacc.c  */
#line 775 "gram.y"
    { (yyval.atomList) = NewAtomList (0, (yyvsp[(1) - (1)].atom)); }
    break;

  case 112:

/* Line 1806 of yacc.c  */
#line 778 "gram.y"
    { (yyval.declList) = NewDeclList ((yyvsp[(1) - (3)].atom), 0, (yyvsp[(3) - (3)].declList)); }
    break;

  case 113:

/* Line 1806 of yacc.c  */
#line 780 "gram.y"
    { (yyval.declList) = NewDeclList ((yyvsp[(1) - (1)].atom), 0, 0); }
    break;

  case 116:

/* Line 1806 of yacc.c  */
#line 794 "gram.y"
    { 
			if ((yyvsp[(1) - (4)].symbol))
			{
			    (yyval.declList) = NewDeclList ((yyvsp[(1) - (4)].symbol)->symbol.name, (yyvsp[(2) - (4)].expr), (yyvsp[(4) - (4)].declList)); 
			    (yyval.declList)->symbol = (yyvsp[(1) - (4)].symbol);
			}
			else
			    (yyval.declList) = (yyvsp[(4) - (4)].declList);
		    }
    break;

  case 117:

/* Line 1806 of yacc.c  */
#line 804 "gram.y"
    { 
			if ((yyvsp[(1) - (2)].symbol))
			{
			    (yyval.declList) = NewDeclList ((yyvsp[(1) - (2)].symbol)->symbol.name, (yyvsp[(2) - (2)].expr), 0);
			    (yyval.declList)->symbol = (yyvsp[(1) - (2)].symbol);
			}
			else
			    (yyvsp[(1) - (2)].symbol) = 0;
		    }
    break;

  case 118:

/* Line 1806 of yacc.c  */
#line 815 "gram.y"
    {	
			(yyval.symbol) = ParseNewSymbol ((yyvsp[(0) - (1)].fulltype).publish,
					     (yyvsp[(0) - (1)].fulltype).class,
					     (yyvsp[(0) - (1)].fulltype).type,
					     (yyvsp[(1) - (1)].atom));
		    }
    break;

  case 119:

/* Line 1806 of yacc.c  */
#line 827 "gram.y"
    { (yyval.fulltype) = (yyvsp[(-2) - (1)].fulltype); }
    break;

  case 120:

/* Line 1806 of yacc.c  */
#line 833 "gram.y"
    {
			NamespacePtr	save = CurrentNamespace;
			SymbolPtr	symbol;
			Type		*type = NewTypeFunc ((yyvsp[(1) - (4)].funcDecl).type.type, (yyvsp[(3) - (4)].argType));
			/*
			 * namespace_start pushed a new namespace, make sure
			 * this symbol is placed in the original namespace
			 */
			CurrentNamespace = save->previous;
			symbol = NamespaceFindName (CurrentNamespace, (yyvsp[(1) - (4)].funcDecl).decl->name, True);
			if (symbol && symbol->symbol.forward)
			{
			    if (!TypeIsSupertype (symbol->symbol.type, type))
			    {
				ParseError ("%A redefinition with different type",
					    (yyvsp[(1) - (4)].funcDecl).decl->name);
				symbol = 0;
			    }
			}
			else
			{
			    symbol = ParseNewSymbol ((yyvsp[(1) - (4)].funcDecl).type.publish,
						     (yyvsp[(1) - (4)].funcDecl).type.class, 
						     type,
						     (yyvsp[(1) - (4)].funcDecl).decl->name);
			}
			CurrentNamespace = save;
			(yyval.funcDecl) = (yyvsp[(1) - (4)].funcDecl);
			(yyval.funcDecl).decl->symbol = symbol;
			(yyval.funcDecl).type.type = type;
		    }
    break;

  case 121:

/* Line 1806 of yacc.c  */
#line 866 "gram.y"
    { (yyval.funcDecl).type = (yyvsp[(1) - (3)].fulltype); (yyval.funcDecl).decl = NewDeclList ((yyvsp[(2) - (3)].atom), 0, 0); }
    break;

  case 122:

/* Line 1806 of yacc.c  */
#line 868 "gram.y"
    { (yyval.funcDecl).type = (yyvsp[(1) - (4)].fulltype); (yyval.funcDecl).decl = NewDeclList ((yyvsp[(3) - (4)].atom), 0, 0); }
    break;

  case 123:

/* Line 1806 of yacc.c  */
#line 870 "gram.y"
    { 
			(yyval.funcDecl).type.publish = publish_private;
			(yyval.funcDecl).type.class = class_undef;
			(yyval.funcDecl).type.type = typePoly;
			(yyval.funcDecl).decl = NewDeclList ((yyvsp[(3) - (4)].atom), 0, 0); 
		    }
    break;

  case 124:

/* Line 1806 of yacc.c  */
#line 878 "gram.y"
    { (yyval.expr) = (yyvsp[(2) - (2)].expr); }
    break;

  case 125:

/* Line 1806 of yacc.c  */
#line 880 "gram.y"
    { (yyval.expr) = (yyvsp[(2) - (2)].expr); }
    break;

  case 126:

/* Line 1806 of yacc.c  */
#line 882 "gram.y"
    { (yyval.expr) = 0; }
    break;

  case 127:

/* Line 1806 of yacc.c  */
#line 888 "gram.y"
    { (yyval.fulltype).publish = (yyvsp[(1) - (4)].publish); (yyval.fulltype).class = (yyvsp[(2) - (4)].class); (yyval.fulltype).type = (yyvsp[(3) - (4)].type); }
    break;

  case 128:

/* Line 1806 of yacc.c  */
#line 890 "gram.y"
    { (yyval.fulltype).publish = publish_private; (yyval.fulltype).class = (yyvsp[(1) - (3)].class); (yyval.fulltype).type = (yyvsp[(2) - (3)].type); }
    break;

  case 129:

/* Line 1806 of yacc.c  */
#line 892 "gram.y"
    { (yyval.fulltype).publish = publish_private; (yyval.fulltype).class = class_undef; (yyval.fulltype).type = (yyvsp[(1) - (2)].type); }
    break;

  case 130:

/* Line 1806 of yacc.c  */
#line 898 "gram.y"
    { (yyval.type) = NewTypeFunc ((yyvsp[(2) - (2)].type), (yyvsp[(1) - (2)].argType)); }
    break;

  case 131:

/* Line 1806 of yacc.c  */
#line 900 "gram.y"
    { (yyval.type) = NewTypeArray ((yyvsp[(4) - (4)].type), (yyvsp[(2) - (4)].expr), False); }
    break;

  case 132:

/* Line 1806 of yacc.c  */
#line 902 "gram.y"
    { (yyval.type) = NewTypeArray ((yyvsp[(4) - (4)].type), (yyvsp[(2) - (4)].expr), True); }
    break;

  case 133:

/* Line 1806 of yacc.c  */
#line 904 "gram.y"
    { (yyval.type) = NewTypeArray ((yyvsp[(4) - (4)].type), (yyvsp[(2) - (4)].expr), False); }
    break;

  case 134:

/* Line 1806 of yacc.c  */
#line 906 "gram.y"
    { (yyval.type) = NewTypeHash ((yyvsp[(4) - (4)].type), (yyvsp[(2) - (4)].type)); }
    break;

  case 135:

/* Line 1806 of yacc.c  */
#line 908 "gram.y"
    { (yyval.type) = 0; }
    break;

  case 136:

/* Line 1806 of yacc.c  */
#line 911 "gram.y"
    {
			Type	*top = (yyvsp[(2) - (2)].type);
			Type	*t, **bot = &top;

			/*
			 * Walk down the type chain to hang the
			 * base type off of the end.  This
			 * makes int[]() be an array of functions
			 * rather than a function returning an array
			 */
			while ((t = *bot))
			    switch (t->base.tag) {
			    case type_array:
				bot = &t->array.type;
				break;
			    case type_hash:
				bot = &t->hash.type;
				break;
			    case type_func:
				bot = &t->func.ret;
				break;
			    default:
				assert(0);
			    }
			*bot = (yyvsp[(1) - (2)].type);
			(yyval.type) = top;
		    }
    break;

  case 137:

/* Line 1806 of yacc.c  */
#line 939 "gram.y"
    { (yyval.type) = NewTypeRef ((yyvsp[(2) - (2)].type), True); }
    break;

  case 138:

/* Line 1806 of yacc.c  */
#line 941 "gram.y"
    { (yyval.type) = NewTypeRef (NewTypeRef ((yyvsp[(2) - (2)].type), True), True); }
    break;

  case 139:

/* Line 1806 of yacc.c  */
#line 943 "gram.y"
    { (yyval.type) = NewTypeRef (NewTypeRef ((yyvsp[(2) - (2)].type), False), False); }
    break;

  case 140:

/* Line 1806 of yacc.c  */
#line 945 "gram.y"
    { (yyval.type) = NewTypeRef ((yyvsp[(2) - (2)].type), False); }
    break;

  case 141:

/* Line 1806 of yacc.c  */
#line 947 "gram.y"
    { 
			if (ParseCanonType ((yyvsp[(1) - (3)].type), False) != CanonTypeDefined)
			    YYERROR;
			if (ParseCanonType ((yyvsp[(3) - (3)].type), False) != CanonTypeDefined)
			    YYERROR;
			(yyval.type) = NewTypePlus ((yyvsp[(1) - (3)].type), (yyvsp[(3) - (3)].type)); 
			if (!(yyval.type))
			    YYERROR;
		    }
    break;

  case 143:

/* Line 1806 of yacc.c  */
#line 959 "gram.y"
    {
			AtomListPtr	al;
			StructType	*st;
			MemListPtr	ml;
			int		nelements;

			nelements = 0;
			for (ml = (yyvsp[(3) - (4)].memList); ml; ml = ml->next)
			{
			    for (al = ml->atoms; al; al = al->next)
				nelements++;
			}
			st = NewStructType (nelements);
			nelements = 0;
			for (ml = (yyvsp[(3) - (4)].memList); ml; ml = ml->next)
			{
			    for (al = ml->atoms; al; al = al->next)
			    {
				AddBoxType (&st->types, ml->type);
				StructTypeAtoms(st)[nelements] = al->atom;
				nelements++;
			    }
			}
			(yyval.type) = NewTypeStruct (st);
		    }
    break;

  case 144:

/* Line 1806 of yacc.c  */
#line 985 "gram.y"
    {
			AtomListPtr	al;
			StructType	*st;
			MemListPtr	ml;
			int		nelements;

			nelements = 0;
			for (ml = (yyvsp[(3) - (4)].memList); ml; ml = ml->next)
			{
			    for (al = ml->atoms; al; al = al->next)
				nelements++;
			}
			st = NewStructType (nelements);
			nelements = 0;
			for (ml = (yyvsp[(3) - (4)].memList); ml; ml = ml->next)
			{
			    for (al = ml->atoms; al; al = al->next)
			    {
				AddBoxType (&st->types, ml->type);
				StructTypeAtoms(st)[nelements] = al->atom;
				nelements++;
			    }
			}
			(yyval.type) = NewTypeUnion (st, False);
		    }
    break;

  case 145:

/* Line 1806 of yacc.c  */
#line 1011 "gram.y"
    {
			AtomListPtr	al;
			StructType	*st;
			int		nelements;

			nelements = 0;
			for (al = (yyvsp[(3) - (4)].atomList); al; al = al->next)
			    nelements++;
			
			st = NewStructType (nelements);
			nelements = 0;
			for (al = (yyvsp[(3) - (4)].atomList); al; al = al->next)
			{
			    AddBoxType (&st->types, typePrim[rep_void]);
			    StructTypeAtoms(st)[nelements] = al->atom;
			    nelements++;
			}
			(yyval.type) = NewTypeUnion (st, True);
		    }
    break;

  case 146:

/* Line 1806 of yacc.c  */
#line 1032 "gram.y"
    { (yyval.type) = (yyvsp[(2) - (3)].type); }
    break;

  case 147:

/* Line 1806 of yacc.c  */
#line 1034 "gram.y"
    { (yyval.type) = NewTypeName ((yyvsp[(1) - (1)].expr), 0); }
    break;

  case 149:

/* Line 1806 of yacc.c  */
#line 1038 "gram.y"
    { (yyval.type) = typePoly; }
    break;

  case 164:

/* Line 1806 of yacc.c  */
#line 1056 "gram.y"
    { (yyval.expr) = 0; }
    break;

  case 165:

/* Line 1806 of yacc.c  */
#line 1059 "gram.y"
    { (yyval.expr) = NewExprTree (COMMA, 0, (yyvsp[(1) - (3)].expr)); }
    break;

  case 166:

/* Line 1806 of yacc.c  */
#line 1061 "gram.y"
    { (yyval.expr) = NewExprTree (COMMA, 0, 0); }
    break;

  case 167:

/* Line 1806 of yacc.c  */
#line 1064 "gram.y"
    { (yyval.expr) = NewExprTree (COMMA, 0, (yyvsp[(1) - (3)].expr)); }
    break;

  case 168:

/* Line 1806 of yacc.c  */
#line 1066 "gram.y"
    { (yyval.expr) = NewExprTree (COMMA, 0, 0); }
    break;

  case 169:

/* Line 1806 of yacc.c  */
#line 1069 "gram.y"
    { (yyval.expr) = NewExprTree (COMMA, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr)); }
    break;

  case 170:

/* Line 1806 of yacc.c  */
#line 1071 "gram.y"
    { (yyval.expr) = NewExprTree (COMMA, (yyvsp[(1) - (1)].expr), 0); }
    break;

  case 171:

/* Line 1806 of yacc.c  */
#line 1077 "gram.y"
    { (yyval.memList) = NewMemList ((yyvsp[(2) - (4)].atomList), (yyvsp[(1) - (4)].type), (yyvsp[(4) - (4)].memList)); }
    break;

  case 172:

/* Line 1806 of yacc.c  */
#line 1079 "gram.y"
    { (yyval.memList) = 0; }
    break;

  case 173:

/* Line 1806 of yacc.c  */
#line 1082 "gram.y"
    { (yyval.memList) = NewMemList ((yyvsp[(2) - (4)].atomList), (yyvsp[(1) - (4)].type), (yyvsp[(4) - (4)].memList)); }
    break;

  case 174:

/* Line 1806 of yacc.c  */
#line 1084 "gram.y"
    { (yyval.memList) = 0; }
    break;

  case 176:

/* Line 1806 of yacc.c  */
#line 1091 "gram.y"
    { (yyval.class) = class_undef; }
    break;

  case 182:

/* Line 1806 of yacc.c  */
#line 1100 "gram.y"
    { (yyval.publish) = publish_private; }
    break;

  case 187:

/* Line 1806 of yacc.c  */
#line 1114 "gram.y"
    { (yyval.argType) = (yyvsp[(2) - (3)].argType); }
    break;

  case 188:

/* Line 1806 of yacc.c  */
#line 1116 "gram.y"
    { (yyval.argType) = 0; }
    break;

  case 189:

/* Line 1806 of yacc.c  */
#line 1119 "gram.y"
    { (yyval.argType) = NewArgType ((yyvsp[(1) - (3)].argDecl).type, False, (yyvsp[(1) - (3)].argDecl).name, 0, (yyvsp[(3) - (3)].argType)); }
    break;

  case 190:

/* Line 1806 of yacc.c  */
#line 1121 "gram.y"
    { (yyval.argType) = NewArgType ((yyvsp[(1) - (2)].argDecl).type, (yyvsp[(2) - (2)].bool), (yyvsp[(1) - (2)].argDecl).name, 0, 0); }
    break;

  case 191:

/* Line 1806 of yacc.c  */
#line 1124 "gram.y"
    { 
			ParseCanonType ((yyvsp[(1) - (2)].type), False);
			(yyval.argDecl).type = (yyvsp[(1) - (2)].type); 
			(yyval.argDecl).name = (yyvsp[(2) - (2)].atom); 
		    }
    break;

  case 192:

/* Line 1806 of yacc.c  */
#line 1130 "gram.y"
    { 
			ParseCanonType ((yyvsp[(1) - (1)].type), False);
			(yyval.argDecl).type = (yyvsp[(1) - (1)].type);
			(yyval.argDecl).name = 0; 
		    }
    break;

  case 193:

/* Line 1806 of yacc.c  */
#line 1141 "gram.y"
    { (yyval.argType) = (yyvsp[(2) - (3)].argType); }
    break;

  case 194:

/* Line 1806 of yacc.c  */
#line 1144 "gram.y"
    {
			ArgType	*args;
			Type	*type;

			for (args = (yyvsp[(2) - (2)].argType); args; args = args->next)
			{
			    type = args->type;
			    if (ParseCanonType (type, False) != CanonTypeDefined)
				break;
			    if (args->varargs)
			    {
				type = NewTypeArray (type,
						     NewExprTree (COMMA,
								  NewExprConst (TEN_NUM, 
										NewInt (0)),
								  0),
						     False);
			    }
			    args->symbol = ParseNewSymbol (publish_private,
							   class_arg, 
							   type, args->name);
			}
			(yyval.argType) = (yyvsp[(2) - (2)].argType);
		    }
    break;

  case 195:

/* Line 1806 of yacc.c  */
#line 1169 "gram.y"
    { (yyval.argType) = 0; }
    break;

  case 196:

/* Line 1806 of yacc.c  */
#line 1172 "gram.y"
    { (yyval.argType) = NewArgType ((yyvsp[(1) - (3)].argDecl).type, False, (yyvsp[(1) - (3)].argDecl).name, 0, (yyvsp[(3) - (3)].argType)); }
    break;

  case 197:

/* Line 1806 of yacc.c  */
#line 1174 "gram.y"
    { (yyval.argType) = NewArgType ((yyvsp[(1) - (2)].argDecl).type, (yyvsp[(2) - (2)].bool), (yyvsp[(1) - (2)].argDecl).name, 0, 0); }
    break;

  case 198:

/* Line 1806 of yacc.c  */
#line 1177 "gram.y"
    { (yyval.argDecl).type = (yyvsp[(1) - (2)].type); (yyval.argDecl).name = (yyvsp[(2) - (2)].atom); }
    break;

  case 199:

/* Line 1806 of yacc.c  */
#line 1179 "gram.y"
    { (yyval.argDecl).type = (yyvsp[(1) - (1)].type); (yyval.argDecl).name = 0; }
    break;

  case 200:

/* Line 1806 of yacc.c  */
#line 1182 "gram.y"
    { (yyval.bool) = True; }
    break;

  case 201:

/* Line 1806 of yacc.c  */
#line 1184 "gram.y"
    { (yyval.bool) = False; }
    break;

  case 203:

/* Line 1806 of yacc.c  */
#line 1192 "gram.y"
    { (yyval.expr) = 0; }
    break;

  case 205:

/* Line 1806 of yacc.c  */
#line 1196 "gram.y"
    { 
			DeclList    *decl;

			for (decl = (yyvsp[(2) - (2)].declList); decl; decl = decl->next)
			{
			    if (decl->init)
			    {
				if (!decl->init->base.type)
				    decl->init->base.type = (yyvsp[(1) - (2)].fulltype).type;
			    }
			}

			(yyval.expr) = NewExprDecl (VAR, (yyvsp[(2) - (2)].declList), (yyvsp[(1) - (2)].fulltype).class, (yyvsp[(1) - (2)].fulltype).type, (yyvsp[(1) - (2)].fulltype).publish); 
		    }
    break;

  case 207:

/* Line 1806 of yacc.c  */
#line 1213 "gram.y"
    { (yyval.expr) = NewExprTree(COMMA, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr)); }
    break;

  case 209:

/* Line 1806 of yacc.c  */
#line 1220 "gram.y"
    { (yyval.expr) = 0; }
    break;

  case 210:

/* Line 1806 of yacc.c  */
#line 1223 "gram.y"
    { (yyval.expr) = NewExprTree (COMMA, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr)); }
    break;

  case 211:

/* Line 1806 of yacc.c  */
#line 1225 "gram.y"
    { (yyval.expr) = NewExprTree (COMMA, (yyvsp[(1) - (1)].expr), 0); }
    break;

  case 213:

/* Line 1806 of yacc.c  */
#line 1229 "gram.y"
    { (yyval.expr) = 0; }
    break;

  case 214:

/* Line 1806 of yacc.c  */
#line 1232 "gram.y"
    { (yyval.expr) = NewExprTree (COMMA, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr)); }
    break;

  case 215:

/* Line 1806 of yacc.c  */
#line 1234 "gram.y"
    {	
			ExprPtr	arg = (yyvsp[(2) - (2)].bool) ? NewExprTree (DOTDOTDOT, (yyvsp[(1) - (2)].expr), 0) : (yyvsp[(1) - (2)].expr);
			(yyval.expr) = NewExprTree (COMMA, arg, 0); 
		    }
    break;

  case 216:

/* Line 1806 of yacc.c  */
#line 1240 "gram.y"
    { 
			(yyval.expr) = NewExprTree (OC,
					  NewExprTree (RETURNTOK, 0, (yyvsp[(3) - (3)].expr)),
					  NewExprTree (OC, 0, 0));
		    }
    break;

  case 217:

/* Line 1806 of yacc.c  */
#line 1245 "gram.y"
    { ++funcDepth; }
    break;

  case 218:

/* Line 1806 of yacc.c  */
#line 1245 "gram.y"
    { --funcDepth; (yyval.expr) = (yyvsp[(2) - (2)].expr); }
    break;

  case 219:

/* Line 1806 of yacc.c  */
#line 1251 "gram.y"
    { 
			if ((yyvsp[(2) - (3)].ints) == ASSIGNPOW)
			    (yyval.expr) = NewExprTree (ASSIGNPOW, 
					      BuildName ("Math", "assign_pow"),
					      NewExprTree (ASSIGNPOW, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr)));
			else
			{
			    ExprPtr left = (yyvsp[(1) - (3)].expr);
			    /*
			     * Automatically declare names used in
			     * simple assignements at the top level
			     */
			    if ((yyvsp[(2) - (3)].ints) == ASSIGN && 
				funcDepth == 0 &&
				left->base.tag == NAME && 
				!(left->atom.symbol))
			    {
				(yyvsp[(1) - (3)].expr)->atom.symbol = ParseNewSymbol (publish_private,
								  class_undef, 
								  typePoly, 
								  (yyvsp[(1) - (3)].expr)->atom.atom);
			    }
			    (yyval.expr) = NewExprTree((yyvsp[(2) - (3)].ints), (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr)); 
			}
		    }
    break;

  case 220:

/* Line 1806 of yacc.c  */
#line 1277 "gram.y"
    {
			ParseCanonType ((yyvsp[(1) - (7)].type), False);
			(yyval.expr) = NewExprCode (NewFuncCode ((yyvsp[(1) - (7)].type), (yyvsp[(4) - (7)].argType), (yyvsp[(6) - (7)].expr), (yyvsp[(5) - (7)].value)), 0); 
		    }
    break;

  case 221:

/* Line 1806 of yacc.c  */
#line 1282 "gram.y"
    {   Value	t;
			t = do_Thread_id_to_thread ((yyvsp[(2) - (2)].value));
			if (t == Void)
			{
			    ParseError ("No thread %v", (yyvsp[(2) - (2)].value));
			    YYERROR;
			}
			else
			    (yyval.expr) = NewExprConst(THREAD_CONST, t); 
		    }
    break;

  case 222:

/* Line 1806 of yacc.c  */
#line 1293 "gram.y"
    { (yyval.expr) = NewExprTree(STAR, (yyvsp[(2) - (2)].expr), (Expr *) 0); }
    break;

  case 223:

/* Line 1806 of yacc.c  */
#line 1295 "gram.y"
    { (yyval.expr) = NewExprTree(STAR, NewExprTree (STAR, (yyvsp[(2) - (2)].expr), 0), 0); }
    break;

  case 224:

/* Line 1806 of yacc.c  */
#line 1297 "gram.y"
    { (yyval.expr) = NewExprTree(AMPER, (yyvsp[(2) - (2)].expr), (Expr *) 0); }
    break;

  case 225:

/* Line 1806 of yacc.c  */
#line 1299 "gram.y"
    { (yyval.expr) = NewExprTree(AMPER, 
				       NewExprTree (AMPER, (yyvsp[(2) - (2)].expr), (Expr *) 0), 
				       (Expr *) 0); }
    break;

  case 226:

/* Line 1806 of yacc.c  */
#line 1303 "gram.y"
    { (yyval.expr) = NewExprTree(UMINUS, (yyvsp[(2) - (2)].expr), (Expr *) 0); }
    break;

  case 227:

/* Line 1806 of yacc.c  */
#line 1305 "gram.y"
    { (yyval.expr) = NewExprTree(LNOT, (yyvsp[(2) - (2)].expr), (Expr *) 0); }
    break;

  case 228:

/* Line 1806 of yacc.c  */
#line 1307 "gram.y"
    { (yyval.expr) = NewExprTree(BANG, (yyvsp[(2) - (2)].expr), (Expr *) 0); }
    break;

  case 229:

/* Line 1806 of yacc.c  */
#line 1309 "gram.y"
    { 
			(yyval.expr) = NewExprTree(FACT, 
					 BuildName ("Math", "factorial"),
					 (yyvsp[(1) - (2)].expr));
		    }
    break;

  case 230:

/* Line 1806 of yacc.c  */
#line 1315 "gram.y"
    { (yyval.expr) = NewExprTree(INC, (yyvsp[(2) - (2)].expr), (Expr *) 0); }
    break;

  case 231:

/* Line 1806 of yacc.c  */
#line 1317 "gram.y"
    { (yyval.expr) = NewExprTree(INC, (Expr *) 0, (yyvsp[(1) - (2)].expr)); }
    break;

  case 232:

/* Line 1806 of yacc.c  */
#line 1319 "gram.y"
    { (yyval.expr) = NewExprTree(DEC, (yyvsp[(2) - (2)].expr), (Expr *) 0); }
    break;

  case 233:

/* Line 1806 of yacc.c  */
#line 1321 "gram.y"
    { (yyval.expr) = NewExprTree(DEC, (Expr *) 0, (yyvsp[(1) - (2)].expr)); }
    break;

  case 234:

/* Line 1806 of yacc.c  */
#line 1323 "gram.y"
    { (yyval.expr) = NewExprTree (FORK, (Expr *) 0, (yyvsp[(2) - (2)].expr)); }
    break;

  case 235:

/* Line 1806 of yacc.c  */
#line 1325 "gram.y"
    { (yyval.expr) = NewExprTree(PLUS, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr)); }
    break;

  case 236:

/* Line 1806 of yacc.c  */
#line 1327 "gram.y"
    { (yyval.expr) = NewExprTree(MINUS, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr)); }
    break;

  case 237:

/* Line 1806 of yacc.c  */
#line 1329 "gram.y"
    { (yyval.expr) = NewExprTree(TIMES, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr)); }
    break;

  case 238:

/* Line 1806 of yacc.c  */
#line 1331 "gram.y"
    { (yyval.expr) = NewExprTree(DIVIDE, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr)); }
    break;

  case 239:

/* Line 1806 of yacc.c  */
#line 1333 "gram.y"
    { (yyval.expr) = NewExprTree(DIV, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr)); }
    break;

  case 240:

/* Line 1806 of yacc.c  */
#line 1335 "gram.y"
    { (yyval.expr) = NewExprTree(MOD, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr)); }
    break;

  case 241:

/* Line 1806 of yacc.c  */
#line 1337 "gram.y"
    { 
			(yyval.expr) = NewExprTree(POW, 
					 BuildName ("Math", "pow"), 
					 NewExprTree (POW, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr))); 
		    }
    break;

  case 242:

/* Line 1806 of yacc.c  */
#line 1343 "gram.y"
    {
			(yyval.expr) = NewExprTree (POW,
					  BuildName("Math", "pow"),
					  NewExprTree (POW, (yyvsp[(1) - (2)].expr),
						       NewExprConst (TEN_NUM,
								     NewInt(2))));
		    }
    break;

  case 243:

/* Line 1806 of yacc.c  */
#line 1351 "gram.y"
    {
			(yyval.expr) = NewExprTree (POW,
					  BuildName("Math", "pow"),
					  NewExprTree (POW, (yyvsp[(1) - (2)].expr),
						       NewExprConst (TEN_NUM,
								     NewInt(3))));
		    }
    break;

  case 244:

/* Line 1806 of yacc.c  */
#line 1359 "gram.y"
    { (yyval.expr) = NewExprTree(SHIFTL, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr)); }
    break;

  case 245:

/* Line 1806 of yacc.c  */
#line 1361 "gram.y"
    { (yyval.expr) = NewExprTree(SHIFTR, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr)); }
    break;

  case 246:

/* Line 1806 of yacc.c  */
#line 1363 "gram.y"
    { (yyval.expr) = NewExprTree(QUEST, (yyvsp[(1) - (5)].expr), NewExprTree(COLON, (yyvsp[(3) - (5)].expr), (yyvsp[(5) - (5)].expr))); }
    break;

  case 247:

/* Line 1806 of yacc.c  */
#line 1365 "gram.y"
    { (yyval.expr) = NewExprTree(LXOR, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr)); }
    break;

  case 248:

/* Line 1806 of yacc.c  */
#line 1367 "gram.y"
    { (yyval.expr) = NewExprTree(LAND, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr)); }
    break;

  case 249:

/* Line 1806 of yacc.c  */
#line 1369 "gram.y"
    { (yyval.expr) = NewExprTree(LOR, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr)); }
    break;

  case 250:

/* Line 1806 of yacc.c  */
#line 1371 "gram.y"
    { (yyval.expr) = NewExprTree(AND, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr)); }
    break;

  case 251:

/* Line 1806 of yacc.c  */
#line 1373 "gram.y"
    { (yyval.expr) = NewExprTree(OR, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr)); }
    break;

  case 252:

/* Line 1806 of yacc.c  */
#line 1375 "gram.y"
    { (yyval.expr) = NewExprTree(EQ, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr)); }
    break;

  case 253:

/* Line 1806 of yacc.c  */
#line 1377 "gram.y"
    { (yyval.expr) = NewExprTree(NE, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr)); }
    break;

  case 254:

/* Line 1806 of yacc.c  */
#line 1379 "gram.y"
    { (yyval.expr) = NewExprTree(LT, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr)); }
    break;

  case 255:

/* Line 1806 of yacc.c  */
#line 1381 "gram.y"
    { (yyval.expr) = NewExprTree(GT, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr)); }
    break;

  case 256:

/* Line 1806 of yacc.c  */
#line 1383 "gram.y"
    { (yyval.expr) = NewExprTree(LE, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr)); }
    break;

  case 257:

/* Line 1806 of yacc.c  */
#line 1385 "gram.y"
    { (yyval.expr) = NewExprTree(GE, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr)); }
    break;

  case 259:

/* Line 1806 of yacc.c  */
#line 1388 "gram.y"
    { (yyval.expr) = NewExprConst(TEN_NUM, (yyvsp[(1) - (1)].value)); }
    break;

  case 260:

/* Line 1806 of yacc.c  */
#line 1390 "gram.y"
    { (yyval.expr) = NewExprConst(OCTAL_NUM, (yyvsp[(1) - (1)].value)); }
    break;

  case 261:

/* Line 1806 of yacc.c  */
#line 1392 "gram.y"
    { (yyval.expr) = NewExprConst(OCTAL0_NUM, (yyvsp[(1) - (1)].value)); }
    break;

  case 262:

/* Line 1806 of yacc.c  */
#line 1394 "gram.y"
    { (yyval.expr) = NewExprConst(BINARY_NUM, (yyvsp[(1) - (1)].value)); }
    break;

  case 263:

/* Line 1806 of yacc.c  */
#line 1396 "gram.y"
    { (yyval.expr) = NewExprConst(HEX_NUM, (yyvsp[(1) - (1)].value)); }
    break;

  case 264:

/* Line 1806 of yacc.c  */
#line 1398 "gram.y"
    { (yyval.expr) = NewExprConst(TEN_FLOAT, (yyvsp[(1) - (1)].value)); }
    break;

  case 265:

/* Line 1806 of yacc.c  */
#line 1400 "gram.y"
    { (yyval.expr) = NewExprConst(OCTAL_FLOAT, (yyvsp[(1) - (1)].value)); }
    break;

  case 266:

/* Line 1806 of yacc.c  */
#line 1402 "gram.y"
    { (yyval.expr) = NewExprConst(OCTAL0_FLOAT, (yyvsp[(1) - (1)].value)); }
    break;

  case 267:

/* Line 1806 of yacc.c  */
#line 1404 "gram.y"
    { (yyval.expr) = NewExprConst(BINARY_FLOAT, (yyvsp[(1) - (1)].value)); }
    break;

  case 268:

/* Line 1806 of yacc.c  */
#line 1406 "gram.y"
    { (yyval.expr) = NewExprConst(HEX_FLOAT, (yyvsp[(1) - (1)].value)); }
    break;

  case 269:

/* Line 1806 of yacc.c  */
#line 1408 "gram.y"
    { (yyval.expr) = NewExprConst(CHAR_CONST, (yyvsp[(1) - (1)].value)); }
    break;

  case 270:

/* Line 1806 of yacc.c  */
#line 1410 "gram.y"
    { (yyval.expr) = NewExprConst(STRING_CONST, (yyvsp[(1) - (1)].value)); }
    break;

  case 271:

/* Line 1806 of yacc.c  */
#line 1412 "gram.y"
    { (yyval.expr) = NewExprConst(VOIDVAL, (yyvsp[(1) - (1)].value)); }
    break;

  case 272:

/* Line 1806 of yacc.c  */
#line 1414 "gram.y"
    { (yyval.expr) = NewExprConst(BOOLVAL, (yyvsp[(1) - (1)].value)); }
    break;

  case 273:

/* Line 1806 of yacc.c  */
#line 1416 "gram.y"
    { 
			(yyval.expr) = BuildFullname (0, AtomId ("[]"));
		    }
    break;

  case 274:

/* Line 1806 of yacc.c  */
#line 1420 "gram.y"
    { 
			ParseCanonType ((yyvsp[(2) - (6)].type), False);
			if ((yyvsp[(5) - (6)].expr))
			    (yyvsp[(5) - (6)].expr)->base.type = (yyvsp[(2) - (6)].type);
			(yyval.expr) = NewExprTree (NEW, (yyvsp[(5) - (6)].expr), 0);
			(yyval.expr)->base.type = (yyvsp[(2) - (6)].type);
		    }
    break;

  case 275:

/* Line 1806 of yacc.c  */
#line 1428 "gram.y"
    { 
			(yyvsp[(7) - (8)].expr)->base.type = NewTypeArray (typePoly, (yyvsp[(3) - (8)].expr), True); 
			ParseCanonType ((yyvsp[(7) - (8)].expr)->base.type, False);
			(yyval.expr) = NewExprTree (NEW, (yyvsp[(7) - (8)].expr), 0); 
			(yyval.expr)->base.type = (yyvsp[(7) - (8)].expr)->base.type;
		    }
    break;

  case 276:

/* Line 1806 of yacc.c  */
#line 1435 "gram.y"
    { 
			TypePtr	t = NewTypeArray (typePoly, (yyvsp[(3) - (8)].expr), False);
			ParseCanonType (t, False);
			(yyval.expr) = NewExprTree (NEW, (yyvsp[(7) - (8)].expr), 0); 
			if ((yyvsp[(7) - (8)].expr))
			    (yyvsp[(7) - (8)].expr)->base.type = t;
			(yyval.expr)->base.type = t;
		    }
    break;

  case 277:

/* Line 1806 of yacc.c  */
#line 1444 "gram.y"
    {
			TypePtr t = NewTypeHash (typePoly, (yyvsp[(3) - (8)].type));
			ParseCanonType (t, False);
			(yyval.expr) = NewExprTree (NEW, (yyvsp[(7) - (8)].expr), 0);
			if ((yyvsp[(7) - (8)].expr))
			    (yyvsp[(7) - (8)].expr)->base.type = t;
			(yyval.expr)->base.type = t;
		    }
    break;

  case 278:

/* Line 1806 of yacc.c  */
#line 1453 "gram.y"
    {
			ParseCanonType ((yyvsp[(1) - (3)].type), False);
			(yyval.expr) = NewExprTree (UNION, NewExprAtom ((yyvsp[(3) - (3)].atom), 0, False), 0); 
			(yyval.expr)->base.type = (yyvsp[(1) - (3)].type);
		    }
    break;

  case 279:

/* Line 1806 of yacc.c  */
#line 1459 "gram.y"
    { 
			ParseCanonType ((yyvsp[(2) - (6)].type), False);
			(yyval.expr) = NewExprTree (UNION, NewExprAtom ((yyvsp[(4) - (6)].atom), 0, False), (yyvsp[(6) - (6)].expr)); 
			(yyval.expr)->base.type = (yyvsp[(2) - (6)].type);
		    }
    break;

  case 280:

/* Line 1806 of yacc.c  */
#line 1465 "gram.y"
    { (yyval.expr) = BuildCall ("History", "fetch", 1, NewExprConst (TEN_NUM, (yyvsp[(2) - (2)].value))); }
    break;

  case 281:

/* Line 1806 of yacc.c  */
#line 1467 "gram.y"
    { (yyval.expr) = NewExprTree (DOLLAR, 0, 0); }
    break;

  case 282:

/* Line 1806 of yacc.c  */
#line 1469 "gram.y"
    { (yyval.expr) = (yyvsp[(2) - (3)].expr); }
    break;

  case 283:

/* Line 1806 of yacc.c  */
#line 1471 "gram.y"
    { (yyval.expr) = (yyvsp[(2) - (3)].expr); }
    break;

  case 284:

/* Line 1806 of yacc.c  */
#line 1473 "gram.y"
    { (yyval.expr) = NewExprTree (OS, NewExprTree (STAR, (yyvsp[(1) - (4)].expr), (Expr *) 0), (yyvsp[(3) - (4)].expr)); }
    break;

  case 285:

/* Line 1806 of yacc.c  */
#line 1475 "gram.y"
    { (yyval.expr) = NewExprTree(OS, (yyvsp[(1) - (4)].expr), (yyvsp[(3) - (4)].expr)); }
    break;

  case 286:

/* Line 1806 of yacc.c  */
#line 1477 "gram.y"
    { (yyval.expr) = NewExprTree (OP, (yyvsp[(1) - (4)].expr), (yyvsp[(3) - (4)].expr)); }
    break;

  case 287:

/* Line 1806 of yacc.c  */
#line 1479 "gram.y"
    {
			TypePtr	type = (yyvsp[(5) - (6)].type);
			ParseCanonType (type, False);
			(yyval.expr) = NewExprType (ISTYPE, (yyvsp[(3) - (6)].expr), type);
		    }
    break;

  case 288:

/* Line 1806 of yacc.c  */
#line 1485 "gram.y"
    { (yyval.expr) = NewExprTree (HASMEMBER, (yyvsp[(3) - (6)].expr), NewExprAtom((yyvsp[(5) - (6)].atom), 0, False)); }
    break;

  case 289:

/* Line 1806 of yacc.c  */
#line 1487 "gram.y"
    { (yyval.expr) = NewExprTree(DOT, (yyvsp[(1) - (3)].expr), NewExprAtom ((yyvsp[(3) - (3)].atom), 0, False)); }
    break;

  case 290:

/* Line 1806 of yacc.c  */
#line 1489 "gram.y"
    { (yyval.expr) = NewExprTree(ARROW, (yyvsp[(1) - (3)].expr), NewExprAtom ((yyvsp[(3) - (3)].atom), 0, False)); }
    break;

  case 292:

/* Line 1806 of yacc.c  */
#line 1493 "gram.y"
    { (yyval.value) = Zero; }
    break;

  case 314:

/* Line 1806 of yacc.c  */
#line 1521 "gram.y"
    { (yyval.expr) = 0; }
    break;

  case 315:

/* Line 1806 of yacc.c  */
#line 1523 "gram.y"
    { (yyval.expr) = 0; }
    break;

  case 316:

/* Line 1806 of yacc.c  */
#line 1526 "gram.y"
    { 
			ExprPtr	elts = (yyvsp[(2) - (5)].expr) ? ExprRehang ((yyvsp[(2) - (5)].expr), 0) : 0;
			if ((yyvsp[(4) - (5)].bool))
			{
			    ExprPtr i = elts;
			    while (i->tree.right)
				i = i->tree.right;
			    i->tree.right = NewExprTree (COMMA, 
							 NewExprTree (DOTDOTDOT, 0, 0),
							 0);
			}
			(yyval.expr) = NewExprTree (ARRAY, elts, 0); 
		    }
    break;

  case 317:

/* Line 1806 of yacc.c  */
#line 1540 "gram.y"
    {
			(yyval.expr) = NewExprTree (COMP, NewExprTree (COMP, (yyvsp[(4) - (9)].expr), (yyvsp[(5) - (9)].expr)), (yyvsp[(7) - (9)].expr));
		    }
    break;

  case 318:

/* Line 1806 of yacc.c  */
#line 1545 "gram.y"
    { (yyval.expr) = (yyvsp[(2) - (2)].expr); }
    break;

  case 320:

/* Line 1806 of yacc.c  */
#line 1549 "gram.y"
    { (yyval.expr) = NewExprTree (COMMA, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr)); }
    break;

  case 322:

/* Line 1806 of yacc.c  */
#line 1553 "gram.y"
    { 
			SymbolPtr   s;
			s = ParseNewSymbol (publish_private, class_arg, 
					    typePrim[rep_integer], (yyvsp[(1) - (1)].atom));
			(yyval.expr) = NewExprAtom ((yyvsp[(1) - (1)].atom), s, False); 
		    }
    break;

  case 323:

/* Line 1806 of yacc.c  */
#line 1561 "gram.y"
    {
			SymbolPtr   s;
			Atom	    a = AtomId("[]");
			s = ParseNewSymbol (publish_private, class_undef,
					    typePoly, a);
			(yyval.expr) = NewExprAtom (a, s, False);
		    }
    break;

  case 324:

/* Line 1806 of yacc.c  */
#line 1570 "gram.y"
    { (yyval.expr) = NewExprTree (COMMA, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr)); }
    break;

  case 325:

/* Line 1806 of yacc.c  */
#line 1572 "gram.y"
    { (yyval.expr) = NewExprTree (COMMA, 0, (yyvsp[(1) - (1)].expr)); }
    break;

  case 329:

/* Line 1806 of yacc.c  */
#line 1583 "gram.y"
    { (yyval.expr) = 0; }
    break;

  case 330:

/* Line 1806 of yacc.c  */
#line 1585 "gram.y"
    { (yyval.expr) = 0; }
    break;

  case 331:

/* Line 1806 of yacc.c  */
#line 1588 "gram.y"
    {
			ExprPtr elts = (yyvsp[(2) - (4)].expr) ? ExprRehang ((yyvsp[(2) - (4)].expr), 0) : 0;
			(yyval.expr) = NewExprTree (HASH, elts, 0);
		    }
    break;

  case 332:

/* Line 1806 of yacc.c  */
#line 1594 "gram.y"
    { (yyval.expr) = NewExprTree (COMMA, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr)); }
    break;

  case 333:

/* Line 1806 of yacc.c  */
#line 1596 "gram.y"
    { (yyval.expr) = NewExprTree (COMMA, 0, (yyvsp[(1) - (1)].expr)); }
    break;

  case 334:

/* Line 1806 of yacc.c  */
#line 1599 "gram.y"
    { (yyval.expr) = NewExprTree (DARROW, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr)); }
    break;

  case 335:

/* Line 1806 of yacc.c  */
#line 1601 "gram.y"
    { (yyval.expr) = NewExprTree (DARROW, 0, (yyvsp[(2) - (2)].expr)); }
    break;

  case 338:

/* Line 1806 of yacc.c  */
#line 1610 "gram.y"
    { (yyval.expr) = NewExprTree (STRUCT, ExprRehang ((yyvsp[(2) - (4)].expr), 0), 0); }
    break;

  case 339:

/* Line 1806 of yacc.c  */
#line 1613 "gram.y"
    { (yyval.expr) = NewExprTree (COMMA, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr)); }
    break;

  case 340:

/* Line 1806 of yacc.c  */
#line 1615 "gram.y"
    { (yyval.expr) = NewExprTree (COMMA, 0, (yyvsp[(1) - (1)].expr)); }
    break;

  case 341:

/* Line 1806 of yacc.c  */
#line 1618 "gram.y"
    { (yyval.expr) = NewExprTree (ASSIGN, NewExprAtom ((yyvsp[(1) - (3)].atom), 0, False), (yyvsp[(3) - (3)].expr)); }
    break;

  case 342:

/* Line 1806 of yacc.c  */
#line 1620 "gram.y"
    { (yyval.expr) = NewExprTree (ASSIGN, NewExprAtom ((yyvsp[(1) - (3)].atom), 0, False), (yyvsp[(3) - (3)].expr)); }
    break;

  case 343:

/* Line 1806 of yacc.c  */
#line 1622 "gram.y"
    { (yyval.expr) = NewExprTree (ASSIGN, NewExprAtom ((yyvsp[(2) - (4)].atom), 0, False), (yyvsp[(4) - (4)].expr)); }
    break;

  case 344:

/* Line 1806 of yacc.c  */
#line 1624 "gram.y"
    { (yyval.expr) = NewExprTree (ASSIGN, NewExprAtom ((yyvsp[(2) - (4)].atom), 0, False), (yyvsp[(4) - (4)].expr)); }
    break;

  case 348:

/* Line 1806 of yacc.c  */
#line 1630 "gram.y"
    { (yyval.expr) = NewExprTree (ANONINIT, 0, 0); }
    break;



/* Line 1806 of yacc.c  */
#line 5698 "gram.c"
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 2067 of yacc.c  */
#line 1632 "gram.y"


static void
DeclListMark (void *object)
{
    DeclListPtr	dl = object;

    MemReference (dl->next);
    MemReference (dl->init);
}

DataType DeclListType = { DeclListMark, 0, "DeclListType" };

DeclListPtr
NewDeclList (Atom name, ExprPtr init, DeclListPtr next)
{
    ENTER ();
    DeclListPtr	dl;

    dl = ALLOCATE (&DeclListType, sizeof (DeclList));
    dl->next = next;
    dl->name = name;
    dl->symbol = 0;
    dl->init = init;
    RETURN (dl);
}

static void
MemListMark (void *object)
{
    MemListPtr	ml = object;

    MemReference (ml->next);
    MemReference (ml->type);
    MemReference (ml->atoms);
}

DataType MemListType = { MemListMark, 0, "MemListType" };

MemListPtr
NewMemList (AtomListPtr atoms, Type *type, MemListPtr next)
{
    ENTER ();
    MemListPtr	ml;

    ml = ALLOCATE (&MemListType, sizeof (MemList));
    ml->next = next;
    ml->type = type;
    ml->atoms = atoms;
    RETURN (ml);
}


extern NamespacePtr	CurrentNamespace;
FramePtr	CurrentFrame;

Value
lookupVar (char *ns, char *n)
{
    ENTER ();
    Value	    v;
    SymbolPtr	    symbol;
    NamespacePtr    namespace;
    Bool	    search;

    search = True;
    namespace = CurrentNamespace;
    if (ns)
    {
	symbol = NamespaceFindName (CurrentNamespace, AtomId (ns), True);
	if (symbol && symbol->symbol.class == class_namespace)
	    namespace = symbol->namespace.namespace;
	else
	    namespace = 0;
    }
    if (namespace)
	symbol = NamespaceFindName (namespace, AtomId (n), search);
    else
	symbol = 0;
    if (symbol && symbol->symbol.class == class_global)
	v = BoxValue (symbol->global.value, 0);
    else
	v = Void;
    RETURN (v);
}

void
setVar (NamespacePtr namespace, char *n, Value v, Type *type)
{
    ENTER ();
    Atom	atom;
    SymbolPtr	symbol;

    atom = AtomId (n);
    symbol = NamespaceFindName (namespace, atom, True);
    if (!symbol)
	symbol = NamespaceAddName (namespace,
				   NewSymbolGlobal (atom, type),
				   publish_private);
    if (symbol->symbol.class == class_global)
	BoxValueSet (symbol->global.value, 0, v);
    EXIT ();
}

void
GetNamespace (NamespacePtr *scope, FramePtr *fp, CodePtr *cp)
{
    *scope = CurrentNamespace;
    *fp = CurrentFrame;
    if (CurrentFrame)
	*cp = CurrentFrame->function->func.code;
    else
	*cp = 0;
}

ExprPtr
BuildName (char *ns, char *n)
{
    ENTER ();
    SymbolPtr	    symbol, ns_symbol = 0;
    Atom	    atom, ns_atom = 0;
    Bool	    search = True;
    NamespacePtr    namespace = CurrentNamespace;
    ExprPtr	    e;
    Bool	    ns_privateFound = False;
    Bool	    privateFound = False;

    if (ns)
    {
	ns_atom = AtomId (ns);
	ns_symbol = NamespaceFindName (namespace, ns_atom, search);
	if (ns_symbol && ns_symbol->symbol.class == class_namespace)
	    namespace = ns_symbol->namespace.namespace;
	else
	{
	    if (!ns_symbol)
		ns_privateFound = NamespaceIsNamePrivate (namespace, ns_atom, search);
	    namespace = 0;
	}
	search = False;
    }
    atom = AtomId (n);
    if (namespace)
    {
	symbol = NamespaceFindName (namespace, atom, search);
	if (!symbol)
	    privateFound = NamespaceIsNamePrivate (namespace, atom, search);
    }
    else
	symbol = 0;
    e = NewExprAtom (atom, symbol, privateFound);
    if (ns_atom)
	e = NewExprTree (COLONCOLON, NewExprAtom (ns_atom, ns_symbol, ns_privateFound), e);
    RETURN (e);
}

static Value
AtomString (Atom id)
{
    ENTER ();
    RETURN (NewStrString (AtomName (id)));
}

ExprPtr
BuildRawname (ExprPtr colonnames, Atom name)
{
    ENTER ();
    int     len;
    Value   array;
    ExprPtr e;

    len = 1;
    for (e = colonnames; e; e = e->tree.left)
	len++;
    array = NewArray (False, False, typePrim[rep_string], 1, &len);
    len--;
    ArrayValueSet (&array->array, len, AtomString (name));
    e = colonnames;
    while (--len >= 0)
    {
	ArrayValueSet (&array->array, len, AtomString (e->tree.right->atom.atom));
	e = e->tree.left;
    }
    e = NewExprConst (POLY_CONST, array);
    RETURN (e);
}

	    
ExprPtr
BuildFullname (ExprPtr left, Atom atom)
{
    ENTER ();
    NamespacePtr    namespace;
    SymbolPtr	    symbol;
    Bool	    search;
    ExprPtr	    nameExpr;
    Bool	    privateFound = False;

    if (left)
    {
	if (left->base.tag == COLONCOLON)
	    symbol = left->tree.right->atom.symbol;
	else
	    symbol = left->atom.symbol;
	if (symbol && symbol->symbol.class == class_namespace)
	    namespace = symbol->namespace.namespace;
	else
	    namespace = 0;
        search = False;
    }
    else
    {
	namespace = CurrentNamespace;
	search = True;
    }
    if (namespace)
    {
	symbol = NamespaceFindName (namespace, atom, search);
	if (!symbol)
	    privateFound = NamespaceIsNamePrivate (namespace, atom, search);
    }
    else
	symbol = 0;
    nameExpr = NewExprAtom (atom, symbol, privateFound);
    if (left)
	nameExpr = NewExprTree (COLONCOLON, left, nameExpr);
    RETURN (nameExpr);
}

ExprPtr
BuildCall (char *scope, char *name, int nargs, ...)
{
    ENTER ();
    va_list	    alist;
    ExprPtr	    args, *prev;
    ExprPtr	    f;
    ExprPtr	    e;

    va_start (alist, nargs);
    prev = &args;
    args = 0;
    while (nargs--)
    {
	*prev = NewExprTree (COMMA, va_arg (alist, ExprPtr), 0);
	prev = &(*prev)->tree.right;
    }
    va_end (alist);
    f = BuildName (scope, name);
    e = NewExprTree (OP, f, args);
#ifdef DEBUG
    printExpr (stdout, e, -1, 0);
    printf ("\n");
#endif
    RETURN (e);
}

/*
 * Walk for() loop arguments and normalize the list
 */
static Expr *
ParseCanonFor (Expr *expr)
{
    if (!expr || !expr->tree.right) {
        ParseError ("Too few exprs in for()\n");
        return 0;
    }
    if (!expr->tree.right->tree.right) {
        /* 2-argument for() */
        expr = NewExprTree(FOR, 0, expr);
    }
    if (expr->tree.right->tree.right->tree.right) {
        ParseError ("Too many exprs in for()\n");
        return 0;
    }
    return expr;
}

/*
 * Walk a type structure and resolve any type names
 */
static CanonTypeResult
ParseCanonType (TypePtr type, Bool forwardAllowed)
{
    ArgType	    *arg;
    int		    n;
    CanonTypeResult ret = CanonTypeDefined, t;
    Bool	    anyResolved;
    
    if (!type)
    {
	ParseError ("Type missing inside compiler");
	return False;
    }
    switch (type->base.tag) {
    case type_prim:
	break;
    case type_name:
	if (!TypeNameType(type))
	{
	    if (!type->name.name)
	    {
		ExprPtr e;
		e = type->name.expr;
		if (e->base.tag == COLONCOLON)
		    e = e->tree.right;
		type->name.name = e->atom.symbol;
		if (!type->name.name)
		{
		    ParseError ("No typedef \"%A\" in namespace",
				e->atom.atom);
		    ret = CanonTypeUndefined;
		    break;
		}
	    }
	    if (type->name.name->symbol.class != class_typedef)
	    {
		ParseError ("Symbol \"%A\" not a typedef", 
			    type->name.name->symbol.name);
		ret = CanonTypeUndefined;
	    }
	    else if (!TypeNameType(type))
	    {
		if (!forwardAllowed)
		    ParseError ("Typedef \"%A\" not defined yet", 
				type->name.name->symbol.name);
		ret = CanonTypeForward;
	    }
	    else
	    {
		ret = ParseCanonType (TypeNameType(type), forwardAllowed);
	    }
	}
	break;
    case type_ref:
	ret = ParseCanonType (type->ref.ref, True);
	if (ret == CanonTypeForward)
	    ret = CanonTypeDefined;
	break;
    case type_func:
	if (type->func.ret)
	    ret = ParseCanonType (type->func.ret, forwardAllowed);
	for (arg = type->func.args; arg; arg = arg->next)
	{
	    t = ParseCanonType (arg->type, forwardAllowed);
	    if (t < ret)
		ret = t;
	}
	break;
    case type_array:
	ret = ParseCanonType (type->array.type, forwardAllowed);
	break;
    case type_hash:
	ret = ParseCanonType (type->hash.type, forwardAllowed);
	t = ParseCanonType (type->hash.keyType, forwardAllowed);
	if (t < ret)
	    ret = t;
	break;
    case type_struct:
	for (n = 0; n < type->structs.structs->nelements; n++)
	{
	    StructType   *st = type->structs.structs;

	    t = ParseCanonType (BoxTypesElements(st->types)[n], forwardAllowed);
	    if (t < ret)
		ret = t;
	}
	break;
    case type_union:
	anyResolved = False;
	for (n = 0; n < type->structs.structs->nelements; n++)
	{
	    StructType   *st = type->structs.structs;

	    t = ParseCanonType (BoxTypesElements(st->types)[n], True);
	    if (t < ret)
		ret = t;
	    if (t == CanonTypeDefined)
		anyResolved = True;
	}
	if (ret == CanonTypeForward)
	{
	    if (anyResolved)
		ret = CanonTypeDefined;
	    else if (!forwardAllowed)
		ParseError ("No member of '%T' defined yet", type);
	}
	break;
    case type_types:
	break;
    }
    return ret;
}

static SymbolPtr
ParseNewSymbol (Publish publish, Class class, Type *type, Atom name)
{
    ENTER ();
    SymbolPtr	s = 0;
    
    if (class == class_undef)
	class = funcDepth ? class_auto : class_global;

    if (class == class_namespace || 
	(class == class_typedef && type == 0) || 	
	ParseCanonType (type, False) == CanonTypeDefined)
    {
	switch (class) {
	case class_const:
	    s = NewSymbolConst (name, type);
	    break;
	case class_global:
	    s = NewSymbolGlobal (name, type);
	    break;
	case class_static:
	    s = NewSymbolStatic (name, type);
	    break;
	case class_arg:
	    s = NewSymbolArg (name, type);
	    break;
	case class_auto:
	    s = NewSymbolAuto (name, type);
	    break;
	case class_exception:
	    s = NewSymbolException (name, type, Void);
	    break;
	case class_typedef:
	    /*
	     * Special case for typedefs --
	     * allow forward declaration of untyped
	     * typedef names, then hook the
	     * new type to the old name
	     */
	    if (type)
	    {
		s = NamespaceFindName (CurrentNamespace, name, False);
		if (s && s->symbol.class == class_typedef && !s->symbol.type)
		{
		    s->symbol.type = type;
		    RETURN (s);
		}
	    }
	    s = NewSymbolType (name, type);
	    break;
	case class_namespace:
	    s = NewSymbolNamespace (name, NewNamespace (CurrentNamespace));
	    break;
	case class_undef:
	    break;
	}
	if (s)
	    NamespaceAddName (CurrentNamespace, s, publish);
    }
    RETURN (s);
}

int
yywrap (void)
{
    if (LexInteractive())
	printf ("\n");
    if (CurrentFrame)
    {
	do_Debug_done ();
	return 0;
    }
    return 1;
}

extern	char *yytext;

void
ParseError (char *fmt, ...)
{
    va_list	args;

    if (LexFileName ())
	FilePrintf (FileStderr, "%A:%d: ",
		    LexFileName (), LexFileLine ());
    va_start (args, fmt);
    FileVPrintf (FileStderr, fmt, args);
    FilePrintf (FileStderr, "\n");
    va_end (args);
}

void
yyerror (char *msg)
{
    ignorenl = 0;
    ParseError ("%s before %S", msg, yytext);
}

